/* Mysites database backup 
SQA_Mysites_ContentDB --> Dev
SQA_Mysites_ContentDB --> Test
SQA_Mysites_ContentDB --> SQA
RAMS_Mysites_PPD_WSS_ContentDB --> PrePROD
RAMS_Mysites_PPD_WSS_ContentDB --> Prod
*/
BACKUP DATABASE [SQA_Mysites_ContentDB] TO  DISK = N'D:\2-2_Backups\SQA_Mysites_ContentDB_Full.BAK' WITH NOFORMAT, NOINIT,  NAME = N'SQA_Mysites_ContentDB-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset where database_name=N'SQA_Mysites_ContentDB' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'SQA_Mysites_ContentDB' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''SQA_Mysites_ContentDB'' not found.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'D:\2-2_Backups\SQA_Mysites_ContentDB_Full.BAK' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO

/*SPconfig database backup 
SharePoint_Config_Integration_DEV --> Dev
RAMS_SP_Config_DB --> Test 
RAMS_SharePoint_Config --> SQA 
RAMS_PPD_SharePoint_Config --> PreProd
RAMS_PPD_SharePoint_Config --> Prod
*/
BACKUP DATABASE [SharePoint_Config_Integration_DEV] TO  DISK = N'D:\2-2_Backups\SharePoint_Config_Integration_DEV_FULL.BAK' WITH NOFORMAT, NOINIT,  NAME = N'SharePoint_Config_Integration_DEV-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset where database_name=N'SharePoint_Config_Integration_DEV' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'SharePoint_Config_Integration_DEV' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''SharePoint_Config_Integration_DEV'' not found.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'D:\2-2_Backups\SharePoint_Config_Integration_DEV_FULL.BAK' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO

/*SPcontent database backup */
BACKUP DATABASE [SP_RAMS_WSS_Content_IRB_Application_DB_2_0] TO  DISK = N'D:\2-2_Backups\SP_RAMS_WSS_Content_IRB_Application_DB_2_0_FUL.BAK' WITH NOFORMAT, NOINIT,  NAME = N'SP_RAMS_WSS_Content_IRB_Application_DB_2_0-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset where database_name=N'SP_RAMS_WSS_Content_IRB_Application_DB_2_0' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'SP_RAMS_WSS_Content_IRB_Application_DB_2_0' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''SP_RAMS_WSS_Content_IRB_Application_DB_2_0'' not found.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'D:\2-2_Backups\SP_RAMS_WSS_Content_IRB_Application_DB_2_0_FUL.BAK' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO

/* RAMS User database backup */
BACKUP DATABASE [RAMS] TO  DISK = N'D:\2-2_Backups\RAMS_FUL.BAK' WITH NOFORMAT, NOINIT,  NAME = N'RAMS-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset where database_name=N'RAMS' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'RAMS' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''RAMS'' not found.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'D:\2-2_Backups\RAMS_FUL.BAK' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO
