var groupPartNames = [];
$(document).ready(changeCommitteeLink());

function changeCommitteeLink() {
	var potentialGroups = {};
	var isMember = function(gid) {
		return potentialGroups[gid];
	};
	var currentUrl = RAMS.Environment.SharePoint.URL;
	var groupPart = "";
	restCall(currentUrl + "_api/Web/CurrentUser/Groups", function(returnedGroups) {
		var i;
		returnedGroups = returnedGroups.d.results;

		for (i = 0; i < returnedGroups.length; i++)
			potentialGroups[returnedGroups[i].Id] = true;
		//should only be assinged to one Users groups
		restCall(currentUrl + "_api/Web/lists/GetByTitle('Committee List')/Items", function(committees) {
			var c, matches = [];
			committees = committees.d.results;

			for (i = 0; i < committees.length; i++) {
				c = committees[i];
				if (isMember(c.CommitteeCoordinatorsId) ||
				    isMember(c.CommitteeMembersId) ||
				    isMember(c.IRBAdministratorsId) ||
				    isMember(c.LocalSiteAdministratorsId) ||
				    isMember(c.LocalSiteLiaisonsId) ||
				    isMember(c.UsersId))
					matches.push(c);
			}
			var facilityLookup="";
			var facilitySite="";
			if (matches.length == 1) {
				var multi=false;
				facilityLookup = matches[0].CommitteeSub_x002d_Site.Url;
				facilityLookup=(facilityLookup.substr(facilityLookup.lastIndexOf('/') + 1));
		        getGroupPartName(currentUrl ,matches[0].UsersId, matches[0], multi);
				
			} else if (matches.length == 0) {
				$(document.body).append("<em>You are not a member of any of the site groups in the Committee List.</em>");
			} else {
				   var multi=true;
        			$(document.body).append("<p><em>You are a group member within several sites on the Committee List:</em></p>");
			        for (i = 0; i < matches.length; i++) {
			        	getGroupPartName(currentUrl ,matches[i].UsersId, matches[i], multi);				     }
			      }
		});
	});
}

function restCall(endpoint, callback){
	jQuery.ajax({
		url: endpoint,
		type: "GET",
		headers: {
			"accept": "application/json; odata=verbose"
		}
	}).done(function(returnedJson){
		callback(returnedJson);
	});
}

function getGroupPartName (currentUrl,usersId, match, multi) {
	restCall(currentUrl + "_api/Web/SiteGroups(" + usersId + ")", function(title) {
		var facilityLookup=match.CommitteeSub_x002d_Site.Url;
	    facilityLookup=(facilityLookup.substr(facilityLookup.lastIndexOf('/') + 1));
		var userGroupTitle=title.d.Title;
		var lastIndex = userGroupTitle.lastIndexOf(" ");
		var groupPartName = userGroupTitle.substring(0, lastIndex);	
	   	if (multi) {
	   		$(document.body).append("<a href='" + "../SitePages/FacilityHome.html?facilityName=" + facilityLookup + "&facilityTitle=" + match.Title + "&groupPart=" + groupPartName + "'>" 		+ match.Title + "</a><br/>");
	   	}
	   	else {
			var facilitySite="../SitePages/FacilityHome.html?facilityName=" + facilityLookup + "&facilityTitle=" + match.Title + "&groupPart=" + groupPartName;
			window.location.replace(facilitySite);
	   	}
 	

	});
}
