var currentAttachmentID;
var userObject = {};
var localSiteAppObject = {};

function refreshDisplay(refreshType){
    var row, container, pageHeader, sideWell, pageFooter, headerArea;

    $('#refresh-section').remove();
    // $('div#insert').attr("class", "container");
    row = document.createElement("div");
    row.setAttribute("class", "row");
    row.setAttribute("id", "refresh-section");
    $('div#insert').append(row);

    container = document.createElement("div");
    container.setAttribute("class", "col-xs-9");
    row.appendChild(container);

    pageHeader = document.createElement("div");
    pageHeader.setAttribute("class", "page-header");
    pageHeader.setAttribute("tabindex", "0");
    container.appendChild(pageHeader);

    headerArea = $('div.page-header');
    headerArea.empty();

    if(refreshType == "Facility"){
        headerBuilder("Sites", headerArea);
            sendREST("GET", siteUrl.concat("_api/Web/Lists/getByTitle('facility')/Items"), null, function(groupJSON){   
                var currentGroups = groupJSON.d.results;
                var facility, userGroupID, localSiteLiaisonID;
                
                //loop through SharePoint facility groups
                for(var i=0; i<currentGroups.length; i++){
                    facility = currentGroups[i].FacilityName;
                    userGroupID = currentGroups[i].UsersId;
                    localSiteLiaisonID = currentGroups[i].FacilityLiaisonId;
                    
                    userObject[facility] = {};
                    userObject[facility]["userGroupID"] = userGroupID;
                    userObject[facility]["groupID"] = currentGroups[i].Id;
                    userObject[facility]["localSiteLiaisonID"] = localSiteLiaisonID;

                    //use AJAX calls to add user and liaison data for each facility to global object
                    getUsers(userGroupID, facility);
                    getLiaison(localSiteLiaisonID, facility);
                }
                
                grabLocalSiteApplications(assignedID);   //save local site app data to global object
                container.appendChild(facilityDisplay()); //build local site applications page
                  
                pageFooter = document.createElement("div");
                pageFooter.setAttribute("class", "progress-container");
                container.appendChild(pageFooter);
                pageFooter = document.createElement("div");
                pageFooter.setAttribute("class", "button-container");
                container.appendChild(pageFooter);
    
                progressBuilder();  
            });     
    }else if(refreshType == "Personnel"){
        var AOMember = AOMemberCheck();
        if(AOMember == true || (currentUser.Id == spAppData[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId])) 
        {
            readOnlyState = false;
        }

        headerBuilder("Personnel", headerArea);
        sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(groupJSON){
            var currentGroups = groupJSON.d.results;
            var siteUsersGroupID = -1;
            
            for(var i=0; i<currentGroups.length; i++){ //find the site users' group for the user's site
                if(currentGroups[i].Title.indexOf("Users") > -1){
                    siteUsersGroupID = currentGroups[i].Id;
                }
            }
            
            //perform REST calls if we found site users group
            if(siteUsersGroupID > 0){ //assuming user belongs to only one site
                sendREST("GET", siteUrl.concat("_api/Web/SiteGroups("+siteUsersGroupID+")/Users"), null, function(siteUsers){
                        sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(studyMembers){
                            container.appendChild(personnelDisplay(studyMembers, siteUsers));
                            //container.appendChild(editPersonnelDisplay());
            
                            pageFooter = document.createElement("div");
                            pageFooter.setAttribute("class", "progress-container");
                            container.appendChild(pageFooter);
                            pageFooter = document.createElement("div");
                            pageFooter.setAttribute("class", "button-container");
                            container.appendChild(pageFooter);
            
                            progressBuilder();
                            $("[value='Save Progress']").attr("onclick", "insertPerson()");
                            //$("[value='Save Progress']").attr("onkeypress", "insertPerson()");
                        });
                });
            }
       });
        
    }else if(refreshType == "Files"){
        headerBuilder("Attachments", headerArea);

        sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files?$expand=ListItemAllFields"), null, function(returnedFiles){
            //attachments = filterChecklists(returnedFiles.d.results, "-RAMS-");
            attachments = returnedFiles.d.results;
            container.appendChild(attachmentsDisplay(attachments));

            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "progress-container");
            container.appendChild(pageFooter);
            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "button-container");
            container.appendChild(pageFooter);

            progressBuilder();            
        });
    }

    sideWell = document.createElement("div");
    sideWell.setAttribute("class", "col-xs-3 toolbar");
    row.appendChild(sideWell);

    sideColumnBuilder(null);
};

/* add the users found to the global object userObject */
function addUserArray(data, facility){
    var userArray = [];
    var user = data.d.results;
    
    for(var i=0; i<user.length; i++){
        userArray.push(user[i].Title);
        userObject[facility][user[i].Title] = {};
        userObject[facility][user[i].Title]["id"] = user[i].Id;
    }
    userObject[facility]["users"] = userArray;
}

/* return the JSON of the users belonging to a site group */
function getUsers(groupID, facility){ //replace committee with facility
    return $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/sitegroups("+groupID+")/users"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            addUserArray(json, facility);
        }
    });
}

/* add the local site liaison found to the global object userObject */
function addLiaison(data, facility){
/* TAR data is a user object
    var user = data.d.results;
    userObject[facility]["localSiteLiaison"] = user[0].Title;
*/
    var user = data.d;
    userObject[facility]["localSiteLiaison"] = user.Title;
    
}

/* return the JSON of the local site liaison belonging to a site group */
function getLiaison(localSiteLiaisonID, facility){
/* Facility Local Site Liaison is a user, not a group. Leaving this in case it becomes a group later.
    return $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/sitegroups("+localSiteLiaisonID+")/users"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            addLiaison(json, facility);
        }
    });*/
    return $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/siteusers/getbyid("+localSiteLiaisonID+")"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            addLiaison(json, facility);
        }
    });
}


function personnelDisplay(studyMembers, siteUsers){
    var container, table, tableDiv, tbody, trow, skipFlag, cell, buttonID;

     // var selectUsers = [];
    // var tempList = ramsUsers.values();
    //******************************** NEED THIS TO WORK OFF OF A SP USER GROUP

    // //not including users who are already in the table and are active
    // for(var i=0; i<tableUsers.length; i++){
    //     skipFlag = false;
    //     for(var j=0; j<returnedMembers.length; j++){
    //         if((tableUsers[i].displayName == returnedMembers[j].user.displayName) && (returnedMembers[j].memberRole != "RAMS Reviewer")/*&&(returnedMembers[j].activeMember)*/){
    //             skipFlag = true;
    //         }
    //     }
    //     if(!skipFlag)
    //         selectUsers.push(tableUsers[i].displayName);
    // }

    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
    table = tableHeaderHelper("Personnel", [/*"VA",*/ "Name", "Study Team?", "Role", "COI Required?", "Edit Study?", "Purpose", "Notify?", "Update"]);
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");

    /*Table Body*/
    tbody = document.createElement("tbody");

    /*first row*/
    // trow = document.createElement("tr");
    // //not va
    // trow.appendChild(checkboxCellHelper("initVA", "Is Person not in VA", "swapForNonVA('initVA', 'initPerson')"));
    // //blank space
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(selectCellHelper("initPerson", "Select Person to Add", ["Please Select a User"].concat(selectUsers), null));
    // //study team
    // trow.appendChild(checkboxCellHelper("initStudyTeam", "Is Person on Study Team", null));
    // //blank space//role
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(selectCellHelper("initPersonRole", "Person's Role", ["Principal Investigator", "Clinical Coordinator", "Contractor"], null));
    // //COI required
    // trow.appendChild(checkboxCellHelper("initCOIReq", "Does Person Require COI", null));
    // //write permissions
    // trow.appendChild(checkboxCellHelper("initWritePerm", "Does Person have Write Permissions", null));
    // //explination
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(textareaCellHelper("td", "initExplanation", "Explination of Person"));
    // //notifications
    // trow.appendChild(checkboxCellHelper("initNotify", "Does Person want notifications", null));
    // //add/remove
    // //trow.appendChild(buttonCellHelper("Add", "insertPerson()"));
    // trow.appendChild(textCellHelper("td", ""));

    // tbody.appendChild(trow);

    // /*Second row*/
    // trow = document.createElement("tr");

    // //blank
    // trow.appendChild(textCellHelper("td", ""));

    // //name
    // cell = selectCellHelper("initPerson", "Select Person to Add", ["Please Select a User"].concat(selectUsers), null);
    // cell.setAttribute("colspan", "2");
    // trow.appendChild(cell);

    // //role
    // cell = selectCellHelper("initPersonRole", "Person's Role", ["Please Select a Role", "Clinical Coordinator", "Contractor", "Scientist"], null)
    // cell.setAttribute("colspan", "2");
    // trow.appendChild(cell);

    // //purpose
    // cell = textareaCellHelper("td", "initExplanation", "Explination of Person");
    // cell.setAttribute("colspan", "3");
    // trow.appendChild(cell);

    // //add person
    // trow.appendChild(buttonCellHelper("Add", "insertPerson()"));

    // tbody.appendChild(trow);

   for(var i=0; i<studyMembers.length; i++){
        buttonID = "update"+i;     
        buttonID_Remove = "remove" + i;
        
        trow = document.createElement("tr");
        trow.setAttribute("tabindex", "0");

        //non VA
        //trow.appendChild(returnChecked(returnedMembers[i].vaUser));
        //name
        trow.appendChild(textCellHelper("td", studyMembers[i].user.displayName));
        //study team
        trow.appendChild(returnChecked(studyMembers[i].teamMember));
        //role
        trow.appendChild(textCellHelper("td", studyMembers[i].memberRole));
        //coi required
        trow.appendChild(returnChecked(studyMembers[i].coiRequired));
        //write permissions
        trow.appendChild(returnChecked(studyMembers[i].writePermissions));
        //explination
        trow.appendChild(textCellHelper("td", studyMembers[i].explaination));
        //notifications
        trow.appendChild(returnChecked(studyMembers[i].notifications));
        //remove
        // if(returnedMembers[i].activeMember == true){
        //     trow.appendChild(buttonCellHelper("Deactivate", "deactivateUser('"+returnedMembers[i].user.usersID+"')"));
        // }else{
        //     trow.appendChild(buttonCellHelper("Activate", "activateUser('"+returnedMembers[i].user.usersID+"')"));
        // }
        //console.log("member: "+ returnedMembers[i].user.displayName + " with role: " + returnedMembers[i].memberRole);
        if((studyMembers[i].memberRole == "Principal Investigator") || (studyMembers[i].memberRole == "Co-Principal Investigator")){ 
            trow.appendChild(buttonCellHelper("Update", "updatePerson('"+studyMembers[i].user.displayName+"')", buttonID, true)); //disable update button for PI and CoPI
            trow.appendChild(buttonCellHelper("Remove", "removePerson('"+studyMembers[i].user.usersID+"')", buttonID_Remove, true)); //disable remove button for PI and CoPI
        }else{ 
            trow.appendChild(buttonCellHelper("Update", "updatePerson('"+studyMembers[i].user.displayName+"')", buttonID)); //leave update button enabled
            trow.appendChild(buttonCellHelper("Remove", "removePerson('"+studyMembers[i].user.usersID+"')", buttonID_Remove)); //leave remove button enabled
        }
        tbody.appendChild(trow);
    }

    table.appendChild(tbody);
    tableDiv.appendChild(table);
    //adding in the edit questions for the rows in the table
    //tableDiv.appendChild(editPersonnelDisplay(returnedMembers, tableUsers));
    container.appendChild(tableDiv);
    container.appendChild(editPersonnelDisplay(studyMembers, siteUsers));
    return container;
}

function buildUsernameList(JSON){
    var tempList = [];
    for(var i=0; i<JSON.d.results.length; i++){
        tempList.push(JSON.d.results[i].Title);
    }
    return tempList;
}

function editPersonnelDisplay(studyMembers, siteUsers){
    var container;
    var selectUsers = []; //contains final list of site users for drop down
    var skipPerson;

    container = document.createElement("div");
    container.setAttribute("class", "form-content");
    
    var nameIndex, skipPerson;
    var studyMemberNames = [];
    var siteUserNames = buildUsernameList(siteUsers); //create array from siteUsers JSON data
    
    /*add all study member display names to list*/
    for(var i=0; i<studyMembers.length; i++){
        studyMemberNames.push(studyMembers[i].user.displayName);
    }
    /*add site users to selectUsers array (based on role)*/
    for(var j=0; j<siteUserNames.length; j++){ 
        nameIndex = studyMemberNames.indexOf(siteUserNames[j]); //check if site user is on the study member list
        if(nameIndex > -1){ //user is on the study member list
            skipPerson = false;
            if((studyMembers[nameIndex].memberRole == "RAMS Reviewer") || (studyMembers[nameIndex].memberRole == "Principal Investigator") || (studyMembers[nameIndex].memberRole == "Co-Principal Investigator")){
                skipPerson = true;
            }
            if(!skipPerson){ //if study member is not a reviewer, PI or Co-PI
                selectUsers.push(siteUserNames[j]);
            }
        }else{ //user is not on the study member list
            selectUsers.push(siteUserNames[j]);
        }
    }
    
    //need to capture how many pixels each row takes up, then we want to change the height of div-table-content-big
    //to reflect how much room the table actually

    //container.appendChild(radioFieldHelper("initVA", "Is the person you are adding in the VA?", ["Yes", "No"]));
    container.appendChild(selectFieldHelper("initPerson", "Select a user to add or update:", ["Please Select a User"].concat(selectUsers), "updatePerson()"));
    container.appendChild(radioFieldHelper("initStudyTeam", "Is this user on your study team?", ["Yes", "No"]));
    container.appendChild(selectFieldHelper("initPersonRole", "What role will this user play?", ["Investigator","Co-Investigator","Sub-Investigator","Biostatistician","Clinical Coordinator","Collaborator","CSP Program Manager","Data Manager","Lab Manager","Lab Technician","National Study Coordinator","Nurse Assessor","Pharmacist","Pharmacy Technician","Regulatory Coordinator","Research Assistant","Research Nurse","Statistician","Study Coordinator"]));
    container.appendChild(radioFieldHelper("initCOIReq", "Does this user have a Conflict of Interest?", ["Yes", "No"]));
    container.appendChild(radioFieldHelper("initWritePerm", "Do you want this user to be able to edit your application?", ["Yes", "No"]));
    container.appendChild(textFieldHelper("initExplanation", "If needed, please elaborate on the user being added."));
    container.appendChild(radioFieldHelper("initNotify", "Do you want this user to recieve notifications pertaining to this study?", ["Yes", "No"]));
    container.appendChild(radioFieldHelper("initActivate", "Do you want to give this user access to your application?", ["Yes", "No"]));

    return container;
};

function attachmentsDisplay(returnedFiles){
    var container, link, paragraph, text; 
    var table, tableDiv, tbody, trow, dateAdded, cell;

    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
//    if(readOnlyState == false){
//        table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type", "Remove"]);
//    }else{
//        table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type"]);
//    }
    /*Add link to template*/
    paragraph = document.createElement("P");
    text = document.createTextNode("Click the link to download the ");
    
    link = document.createElement("A");
    link.href = "/sites/IRBApplications/FormTemplates/VHA%20form%2010-0493_Authorization%20for%20Use%20%20Release%20of%20IIHI%20for%20VHA%20Research%20(9-2015).pdf";
    link.target = "_blank"; //open document in new window or tab
    link.innerHTML = "HIPAA Template";
    
    paragraph.appendChild(text);
    paragraph.appendChild(link);
    container.appendChild(paragraph);
    
    table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type", "Remove", "Update"]);
    
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body*/
    tbody = document.createElement("tbody");
    
    for(var i=0; i<returnedFiles.length; i++){
        trow = document.createElement("tr");
        trow.setAttribute("tabindex", "0")
        
        trow.appendChild(linkCellHelper("td", (returnedFiles[i].Name), "Study%20Team", returnedFiles[i].Name));
        dateAdded = returnedFiles[i].TimeCreated.split("T")[1].replace("Z", "") + " on " + returnedFiles[i].TimeCreated.split("T")[0];
        trow.appendChild(textCellHelper("td", dateAdded));
        trow.appendChild(textCellHelper("td", returnedFiles[i].UIVersion)); //version //returnedFiles[i].UIVersion
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.Status)); //status
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.DateApproved)); //date approved
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.DocumentType)); //document type
//        if(readOnlyState == false){
//            trow.appendChild(buttonCellHelper("Remove", "removeAttachment('"+returnedFiles[i].Name+"', 'Study%20Team')"));
//        }
        
        trow.appendChild(buttonCellHelper("Remove", "removeAttachment('"+returnedFiles[i].Name+"', 'Study%20Team')"));
        trow.appendChild(buttonCellHelper("Update", "updateCurrentAttachment('"+returnedFiles[i].ListItemAllFields.ID+"')"));

        tbody.appendChild(trow);
    }

    table.appendChild(tbody);
    tableDiv.appendChild(table);
    container.appendChild(tableDiv);
    return container;
}

function triggerUpdateModal(){
    var modal, modalDialog, modalContent, modalHeader;
    var header, heading1, lineBreak, updateButton, closeButton, text, modalTitle, modalBody, modalFooter;
    var container, tableHeader, table, tableDiv, tbody, trow, trow2, dateAdded, cell;
    var statusTypes = ["Approved", "Changes Requested", "Submitted", "Under Review"];
    
    modal = document.createElement("div");
    modal.setAttribute("id", "updateModal");
    modal.setAttribute("class", "modal");
    
    modalDialog = document.createElement("div");
    modalDialog.setAttribute("role", "document");
    
    modalContent = document.createElement("div");
    modalContent.setAttribute("class", "modal-content");
    modalHeader = document.createElement("div");
    modalHeader.setAttribute("class", "modal-header");
    modalHeader.setAttribute("tabindex", "0");  //start tabbing on modal from header
    
    header = document.createElement("header");
    header.setAttribute("class", "modal-title");
    header.setAttribute("id", "modalTitle2");
    
    heading1 = document.createElement("H2");
    heading1.setAttribute("class", "modal-title");
    text = document.createTextNode("Update Document");
    heading1.appendChild(text);
    header.appendChild(heading1);
    modalHeader.appendChild(header);
    
    lineBreak = document.createElement("br");
    text = document.createTextNode("Please update the status of this document - "+currentAttachmentID+" - by selecting an option below.");
    
    modalFooter = document.createElement("div");
    modalFooter.setAttribute("class", "modal-footer");
    
    modalContent.appendChild(modalHeader);
    modalContent.appendChild(lineBreak);
    modalContent.appendChild(text);
    modalContent.appendChild(lineBreak);
    modalContent.appendChild(buildSelecterHelper("status", "Status", statusTypes, 12));
    modalContent.appendChild(lineBreak);

    
    /*Add Save Document Button*/
    updateButton = document.createElement("button");
    updateButton.setAttribute("class", "btn btn-sm modal-button"); //took out btn-info
    updateButton.setAttribute("data-dismiss", "updateModal")
    updateButton.setAttribute("aria-label", "Update");
    
    updateButton.setAttribute("title", "Update your document"); //hover tip
    updateButton.setAttribute("type", "button");
    updateButton.setAttribute("role", "button");
    updateButton.setAttribute("id", "updateModal");
    
    updateButton.setAttribute("onclick", "updateAttachment()");
    text = document.createTextNode("Update Document");
    updateButton.appendChild(text);
    
    /*Add Close Window Button*/
    closeButton = document.createElement("button");
    closeButton.setAttribute("class", "btn btn-sm modal-button modal-button-right");
    closeButton.setAttribute("data-dismiss", "modal");
    closeButton.setAttribute("aria-label", "Close");
    
    closeButton.setAttribute("title", "Close this window and return to the application"); //hover tip
    closeButton.setAttribute("type", "button");
    closeButton.setAttribute("role", "button");
    closeButton.setAttribute("id", "closeModal2");
    
    closeButton.setAttribute("onclick", "closeAttachmentUpdate()");
    text = document.createTextNode("Close this window");
    closeButton.appendChild(text);
    
    /*Combine Modal Elements*/
    modalFooter.appendChild(updateButton);
    modalFooter.appendChild(closeButton);
    modalContent.appendChild(modalFooter);
    modalDialog.appendChild(modalContent);
    modal.appendChild(modalDialog);
    $('body').append(modal);
    $('#updateModal').popup('show');
}

function updateCurrentAttachment(currentID){
    currentAttachmentID = currentID;
    triggerUpdateModal();
}
function closeAttachmentUpdate(){
    $('#updateModal').popup('hide'); 
    refreshDisplay('Files');
}

/* enable local site investigator dropdown with users from the local site */
function enableInvestigatorDropdown(){
    var facility = $("#addLocalSite").find(':selected').val();
    var users = [];
    var liaison, option, text;
    
    if(facility !== "Please Select a Facility"){
        users = userObject[facility]["users"];
        
        //add available LSIs and enable dropdown
        $("#addLSI").children().remove(); //remove old options
        for(var i=0; i<(users.length); i++){ //add new options
            option = document.createElement("option");
            option.setAttribute("value", users[i]);

            text = document.createTextNode(users[i]);
            option.appendChild(text);
            $("#addLSI").append(option);
        }
        $("#addLSI").removeAttr("disabled");
    }
};

//Add local site liaison to Reviewers group on application's list item
function addToReviewersGroup(json, localSiteLiaisonID){
    var application = json.d.results;
    var listItemID = application[0].Id;
    var reviewers = application[0].ReviewersId;
    var newData;
    
    if((reviewers) == null){ //no users in reviewers group
        newData = {
                "__metadata": {"type": "SP.Data.ApplicationListItem"},
                "ReviewersId": {'results': [localSiteLiaisonID]}
        };
    }else{ //at least one user in users group
        var reviewersArray = [];
        for (var i=0; i<reviewers.results.length; i++){
            reviewersArray.push(reviewers.results[i]);
        }
        reviewersArray.push(localSiteLiaisonID);
        
        newData = {
                "__metadata": {"type": "SP.Data.ApplicationListItem"},
                "ReviewersId": {'results': reviewersArray}
        };
    }
        
        // Update Application list item
        $.ajax({
            url: siteUrl.concat("_api/Web/Lists/GetByTitle('Application')/Items(" +listItemID+ ")"), //post change to application list
            type: "POST",
            data: JSON.stringify(newData),
            headers: {
                "X-RequestDigest": requestDigest,
                "Content-Type": "application/json;odata=verbose",
                "IF-MATCH": "*",
                "X-HTTP-Method": "MERGE"
            }
        }); 
}

/* After the user confirms the new local site,
 * add a row in SharePoint for the empty local site application.
 * Add the local site liaison for each site to the main
 * application list item (to grant permissions) */
function assignMultiSiteStudy(){
    var localSite = $("#addLocalSite").find(':selected').val();
    var localSiteInvestigator = $("#addLSI").find(':selected').val();
    var localSiteInvestigatorID = userObject[localSite][localSiteInvestigator]["id"];
    var localSiteLiaisonID = userObject[localSite]["localSiteLiaisonID"];
    
    var restUrl = siteUrl.concat("_api/web/lists/getbytitle('Application')/items");
    var principalInvestigatorID = spAppData[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId];
    var coPrincipalInvestigatorID = spAppData[RAMS.Environment.SharePoint.List.Application.CoPrincipalInvestigatorId];
    
    var userGroupID = userObject[localSite]["userGroupID"];
    var groupID = userObject[localSite]["groupID"];
    var sendData, data;
    
    console.log("Local Site Selected: "+localSite+"\nLocal Site Investigator Selected: "+localSiteInvestigator+"\nLocal Site Investigator ID: "+localSiteInvestigatorID+"\nUser Group ID: "+userGroupID+"\nLocal Site ID: "+groupID+"\nLocal Site Liaison ID: "+localSiteLiaisonID);
    
    sendData = confirm("You have selected the following site and investigator:\n\nLocal Site Selected: "+localSite+"\nLocal Site Investigator Selected: "+localSiteInvestigator+"\n\nPress [OK] to confirm your choices.");
    if (sendData) { 
        //1) Add list item for local site application (61) to Application list
        data = {
                "__metadata": {"type": "SP.Data.ApplicationListItem"},
                "ParentStudyID": assignedID, //check
                "ParticipatingSiteId": groupID, 
                "ParticipatingSiteInvestigatorId": localSiteInvestigatorID,
                "ParticipatingSiteLiaisonId": localSiteLiaisonID,
                "ParticipatingSiteApplicationStat": "Not Started",
                "PrincipalInvestigatorId": principalInvestigatorID,
                "CoPIId": coPrincipalInvestigatorID
        }   
        
        $.ajax({
            type: 'POST',
            data: JSON.stringify(data),
            url: restUrl,
            headers: {
                "X-RequestDigest": requestDigest,
                "content-type": "application/json;odata=verbose"
                
            }
        });
         
        //2) Add local site liaison to reviewers group on main application (60) list item
        $.ajax({
                type: "GET",
                url: siteUrl.concat("_api/Web/Lists/GetByTitle('Application')/Items" + "?$filter=Study_ID eq '" + assignedID + "'"),
                headers: {"accept": "application/json; odata=verbose"},
                dataType: 'json',
                success: function(json){
                    addToReviewersGroup(json, localSiteLiaisonID);
                }
        });     
    }
}

/* close window for adding local sites
 * and refresh the page
 */
function closeAddSiteModal(){
    $('#addSiteModal').popup('toggle'); //or can use .popup('hide');
    refreshDisplay('Facility');
}

/*
 * open window that allows user to add
 * local site (w/ local site investigator) 
 * to their study
 */
function triggerAddSiteModal(){
    var modal, modalDialog, modalContent, modalHeader;
    var header, heading1, lineBreak, saveButton, closeButton; 
    var paragraph, text, list, listItem1, listItem2, listItem3, modalTitle, modalBody, modalFooter;
    var container, textDiv, table, tableDiv, tbody, trow, trow2, dateAdded, cell;
    
    var selectFacilities = [];
    var localSites = [];

    //create list of selected local sites
    for(var site in localSiteAppObject){
        if(!localSiteAppObject.hasOwnProperty(site)) continue;
        localSites.push(localSiteAppObject[site]["siteName"]);
    }
    
    //create list of available facilities
    for(var key in userObject){
        if(!userObject.hasOwnProperty(key)) continue;
            if(localSites.indexOf(key) < 0){
                selectFacilities.push(key);
            }
    }

    modal = document.createElement("div");
    modal.setAttribute("class", "modal");
    modal.setAttribute("id", "addSiteModal");
    modal.setAttribute("tabindex", "-1");
    modal.setAttribute("role", "dialog");
    modal.setAttribute("aria-labelledby", "addSiteModal");
    
    modalDialog = document.createElement("div");
    modalDialog.setAttribute("role", "document");
    
    modalContent = document.createElement("div");
    modalContent.setAttribute("class", "modal-content");
    modalHeader = document.createElement("div");
    modalHeader.setAttribute("class", "modal-header");
    modalHeader.setAttribute("tabindex", "0"); //start tabbing on modal from header
    
    header = document.createElement("header");
    header.setAttribute("class", "modal-title");
    header.setAttribute("id", "modalTitle");
    
    heading1 = document.createElement("H2");
    heading1.setAttribute("class", "modal-title");
    text = document.createTextNode("Add Local Site");
    heading1.appendChild(text);
    header.appendChild(heading1);
    modalHeader.appendChild(header);
    
    textDiv = document.createElement("div");
    textDiv.setAttribute("class", "col-xs-12");
    paragraph = document.createElement("p");
    lineBreak = document.createElement("br");
    text = document.createTextNode("To successfully add a participating site to your application, select the facility and the site investigator from the respective dropdown lists. Then click the [Save Data] button to record your changes. Click the [Close This Window] button to return to the table.");
    
    paragraph.appendChild(lineBreak);
    paragraph.appendChild(text);
    textDiv.appendChild(paragraph);
    modalContent.appendChild(textDiv);
    
    modalContent.appendChild(modalHeader);
    modalContent.appendChild(lineBreak);
    modalContent.appendChild(text);
    modalContent.appendChild(lineBreak);
    
    /*Setup for Adding Local Site*/
    container = document.createElement("div");
    container.setAttribute("class", "form-content");
    
    /*Table Division*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big"); //div-table-content-big should be small?
    
    /*Table Style*/
    table = document.createElement("table");
    table.setAttribute("class", "table table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body & Rows*/
    tbody = document.createElement("tbody");
    trow = document.createElement("tr");
    trow.setAttribute("tabindex", "0");
    trow2 = document.createElement("tr");
    
//    trow.appendChild(selectCellHelper("addLocalSite", "Select Facility to add", ["Please Select a Facility"].concat(selectFacilities), "enableInvestigatorDropdown()"));
//    trow2.appendChild(selectCellHelper("addLSI", "Select Investigator", ["Please Select an Investigator"], null, true));
    
    trow.appendChild(buildSelecterHelper("addLocalSite", "Selected Facility: ", ["Please Select a Facility"].concat(selectFacilities), 12, "enableInvestigatorDropdown()"));
    trow2.appendChild(buildSelecterHelper("addLSI", "Selected Local Site Investigator: ", ["Please Select an Investigator"], 12));

    /*Add Table Elements Together*/
    tbody.appendChild(trow);
    tbody.appendChild(trow2);
    table.appendChild(tbody);
    tableDiv.appendChild(table);
    
    container.appendChild(lineBreak);
    container.appendChild(tableDiv);
    
    modalFooter = document.createElement("div");
    modalFooter.setAttribute("class", "modal-footer");
    
    /*Add Save Button*/
    saveButton = document.createElement("button");
    saveButton.setAttribute("class", "btn btn-sm modal-button");
    saveButton.setAttribute("aria-label", "Save Data");
    
    saveButton.setAttribute("title", "Save your site and investigator selections"); //hover tip
    saveButton.setAttribute("type", "button");
    saveButton.setAttribute("role", "button");
    saveButton.setAttribute("id", "saveLocalSite");
    
    saveButton.setAttribute("onclick", "assignMultiSiteStudy()");
    text = document.createTextNode("Save Data");
    saveButton.appendChild(text);
    
    /*Add Close Window Button*/
    closeButton = document.createElement("button");
    closeButton.setAttribute("class", "btn btn-sm modal-button modal-button-right");
    closeButton.setAttribute("data-dismiss", "modal");
    closeButton.setAttribute("aria-label", "Close");
    
    closeButton.setAttribute("title", "Close this window and return to the table"); //hover tip
    closeButton.setAttribute("type", "button");
    closeButton.setAttribute("role", "button");
    closeButton.setAttribute("id", "closeModal");
    

    closeButton.setAttribute("onclick", "closeAddSiteModal()");
    text = document.createTextNode("Close This Window");
    closeButton.appendChild(text);
    
    /*Combine Modal Elements*/
    modalContent.appendChild(container);
    modalFooter.appendChild(saveButton);
    modalFooter.appendChild(closeButton);
    modalContent.appendChild(modalFooter);
    modalDialog.appendChild(modalContent);
    modal.appendChild(modalDialog);
    $('body').append(modal);
    $('#addSiteModal').popup('show');   
}

/* add the user title to the global object localSiteAppObject */
function addUser(data, siteID, property){
    var title = data.d.Title;
    localSiteAppObject[siteID][property] = title;
}

/* return the JSON of the user */
function getUserById(userID, siteID, property){
    return $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/GetUserById("+userID+")/"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            addUser(json, siteID, property);
        }
    });
}

/* add the facility title to the global object localSiteAppObject */
function addFacilityName(data, siteID, property){
    var title = data.d.FacilityName;
    localSiteAppObject[siteID][property] = title;
}

/* return the JSON of the facility item */
function getFacilityName(siteID, property){
    return $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/Lists/GetByTitle('Facility')/GetItemById("+siteID+")/"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            addFacilityName(json, siteID, property);
        }
    });
}

/* Loop through local site SharePoint applications
 * and add the data to the localSiteAppObject for
 * later reference */
function buildLocalSiteObject(json){    
    var applications = json.d.results;
    var parentStudyID, appStatus, siteID, investigatorID, liaisonID, hyperlink, studyID, studyTitle;
    
    for(var i=0; i<applications.length; i++){
        parentStudyID = applications[i].ParentStudyID;
        appStatus = applications[i].ParticipatingSiteApplicationStat;
        siteID = applications[i].ParticipatingSiteId;
        investigatorID = applications[i].ParticipatingSiteInvestigatorId;
        
        liaisonID = applications[i].ParticipatingSiteLiaisonId;
        hyperlink = applications[i].LinkToApplication;
        studyID = applications[i].Study_ID;
        studyTitle = applications[i].StudyTitle;
        
        localSiteAppObject[siteID] = {};
        localSiteAppObject[siteID]["appStatus"] = appStatus;
        localSiteAppObject[siteID]["siteID"] = siteID;
        localSiteAppObject[siteID]["investigatorID"] = investigatorID;
        
        localSiteAppObject[siteID]["liaisonID"] = liaisonID;
        localSiteAppObject[siteID]["linkToApplication"] = hyperlink;
        localSiteAppObject[siteID]["studyID"] = studyID;
        localSiteAppObject[siteID]["studyTitle"] = studyTitle;
        
        console.log("Parent Study ID: "+parentStudyID+"\nLocal Site Application Status: "+appStatus+"\nLocal Site ID: "+siteID+"\nLocal Site Investigator ID: "+investigatorID+"\nLocal Site Liaison ID: "+liaisonID);
        getUserById(investigatorID, siteID, "investigator");
        getUserById(liaisonID, siteID, "liaison");
        getFacilityName(siteID, "siteName");
    }
}

/* Grab all local site SharePoint applications
 * and return the json data for each list item
 */
function grabLocalSiteApplications(assignedID){
    var applicationUrl = siteUrl.concat("_api/web/lists/getbytitle('Application')/items?$filter=ParentStudyID eq '"+assignedID+"'"); 
    return $.ajax({
        async: false,
        type: 'GET',
        url: applicationUrl,
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            buildLocalSiteObject(json);
        },
        error: function(error){alert("Error: "+JSON.stringify(error));}
    });
}   

/* invoke function call to create child study/local site application */
//Passing in Local Site Investigator to be inserted as study member for edit permission
function invokeChildStudy(siteID, investigatorID){
    generateAssignedId("Local", siteID, investigatorID);
}

/*
 * generate local site application page:
 * page allows user to start a new local site study
 * and designate both local site investigator (LSI)
 * and local site liaison (LSL)
 */
function facilityDisplay(){
    var container, table, tableDiv, tbody, trow, counter, buttonID;
    var selectFacilities = [];

    //create list of facilities
    for(var key in userObject){
        if(!userObject.hasOwnProperty(key)) continue;
        selectFacilities.push(key);
    }
    
    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
    table = tableHeaderHelper("Local Site Applications", ["Add Site", "Site Name", "Local Site Investigator", "Local Site Liaison", "Application Name", "Application Link"]);
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body*/
    tbody = document.createElement("tbody");
    
    //add row for each local site application
    counter = 0;
    for (var site in localSiteAppObject){
        if(!localSiteAppObject.hasOwnProperty(site)) continue;
            trow = document.createElement("tr"); //create clean row 
            trow.appendChild(textCellHelper("td", "Site Added"));
            trow.appendChild(textCellHelper("td", (localSiteAppObject[site]["siteName"]))); //use ID to get facility
            trow.appendChild(textCellHelper("td", (localSiteAppObject[site]["investigator"])));
            trow.appendChild(textCellHelper("td", (localSiteAppObject[site]["liaison"])));
            
            /*  Allow access to created local site study 61 if already initiated.
                Allow ability to create local site study 61 based on status of main study 60. */
            if((localSiteAppObject[site]["appStatus"] == "Draft") && (localSiteAppObject[site]["linkToApplication"])){  //study initiated, show study title and link
                trow.appendChild(textCellHelper("td", localSiteAppObject[site]["studyTitle"]));
                trow.appendChild(linkCellHelper("td", localSiteAppObject[site]["studyID"], null, localSiteAppObject[site]["linkToApplication"]["Url"], "_blank"));
            }else if((spAppData.ApplicationStatus == "Approved") || (spAppData.ApplicationStatus == "Approved with Major Modifications") || (spAppData.ApplicationStatus == "Approved with Minor Modifications")){ //main study approved, enable start application button
                trow.appendChild(textCellHelper("td", "No Application Name Available"));
                buttonID = "startapplication"+localSiteAppObject[site]["siteID"];
                trow.appendChild(buttonCellHelper("Start Application", ('invokeChildStudy('+localSiteAppObject[site]["siteID"]+','+localSiteAppObject[site]["investigatorID"]+')'),buttonID));
            }else{ //main study not approved, disable start application button
                trow.appendChild(textCellHelper("td", "No Application Name Available"));
                buttonID = "startapplication"+localSiteAppObject[site]["siteID"];
                trow.appendChild(buttonCellHelper("Start Application", ('invokeChildStudy('+localSiteAppObject[site]["siteID"]+','+localSiteAppObject[site]["investigatorID"]+')'),buttonID, true));
            }
            
            tbody.appendChild(trow);
            counter++;
    }
    
    //create row for adding local sites
    trow = document.createElement("tr");
    trow.appendChild(buttonCellHelper("Add", "triggerAddSiteModal()"));
    trow.appendChild(textCellHelper("td", "No Facility Selected"));
    trow.appendChild(textCellHelper("td", "No Investigator Selected"));
    trow.appendChild(textCellHelper("td", "No Liaison Selected"));
    trow.appendChild(textCellHelper("td", "No Application Name Available"));
    trow.appendChild(textCellHelper("td", "No Application Link Available"));
    tbody.appendChild(trow);

    table.appendChild(tbody);
    tableDiv.appendChild(table);
    container.appendChild(tableDiv);
    return container;
};

function generateLocalApp(facilityID){
    //console.log("generating local application");
    generateAssignedId("Local", facilityID);
};

function swapForNonVA(checkboxID, swapID){
    var tempList;
    var selectUsers = [];

    //remove drop down
    // $('#'+swapID).parent().children().remove();

    if($('#'+checkboxID).is(':checked')){
        $('#'+swapID).parent().replaceWith(textareaCellHelper("td", swapID, "Type in Non VA Person"));
    }else{
        tempList = ramsUsers.values()

        for(var i=0; i<tempList.length; i++){
            selectUsers.push(tempList[i].Title);
        }

        $('#'+swapID).parent().replaceWith(selectCellHelper(swapID, "Select Person to Add", selectUsers, null));
    }
}

function insertFacility(id){
    var facility = $('#'+id).val();
    //var facilities = spAppData.CoordinatingSitesId.results;
    //var liaisons;
    var data, liaisons, facilities;

    if(facility != "Please Select a Facility"){
        sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items"), null, function(json){
            var returnedFacilities = json.d.results;
            
            if(spAppData.CoordinatingSitesLiaisonId == null){
                liaisons = [];    
            }else{
                liaisons = spAppData.CoordinatingSitesLiaisonId.results;
            }

            if(spAppData.CoordinatingSitesId.results.length == 0){
                facilities = [];
            }else{
                //console.log("not null " + JSON.stringify(spAppData.CoordinatingSitesId));
                facilities = spAppData.CoordinatingSitesId.results;
            }

            for(var i=0; i<returnedFacilities.length; i++){
                if(returnedFacilities[i].FacilityName == facility){
                    facilities.push(returnedFacilities[i].Id);
                    liaisons.push(returnedFacilities[i].FacilityLiaisonId);

                    //console.log("we are sending: " + liaisons + " and " + facilities);

                    data = {
                        "__metadata": spAppData.__metadata,
                        "CoordinatingSitesId": {
                            "__metadata": { "type": "Collection(Edm.Int32)"},
                            "results": facilities
                        },
                        "CoordinatingSitesLiaisonId":{
                            "__metadata": {"type": "Collection(Edm.Int32)"},
                            "results": liaisons
                        }
                    }

                    spAppData.CoordinatingSitesId.results = facilities;
                    spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};

                    sendREST("POST", spAppData.__metadata.uri, data, function(){
                        if(spsubsiteAppData != null){
                            sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
                                refreshDisplay("Facility");
                            }, "Merge");
                        }else{
                            refreshDisplay("Facility");
                        }
                    }, "Merge");
                }
            }
        });
    }
}

function removeFacility(facilityID, liaisonID){
    var facilities = [];
    var liaisons = [];
    var data;
    //console.log("we recieved " + facilityID + " and " + liaisonID);

    //grab facilities from appData, identify which one you don't need and resend merge
    // sendREST("GET", siteUrl.concat("RAMSIRBSC/_api/web/lists/getbytitle('Facility')/items"), null, function(json){
    //     var returnedFacilities = json.d.results;
    //         for(var i=0; i<returnedFacilities.length; i++){
    //             if(returnedFacilities[i].Id == id){
                    for(var j=0; j<spAppData.CoordinatingSitesId.results.length; j++){
                        if(spAppData.CoordinatingSitesId.results[j] != facilityID)
                            facilities.push(spAppData.CoordinatingSitesId.results[j]);
                    }
                    for(var j=0; j<spAppData.CoordinatingSitesLiaisonId.results.length; j++){
                        //console.log("checking " + spAppData.CoordinatingSitesLiaisonId.results[j] + " vs " + liaisonID);
                        if(spAppData.CoordinatingSitesLiaisonId.results[j] != liaisonID){
                            //console.log("we want to keep: " + spAppData.CoordinatingSitesLiaisonId.results[j]);
                            liaisons.push(spAppData.CoordinatingSitesLiaisonId.results[j]);
                        }
                    }

                    if(liaisons.length >= 1){
                        data = {
                            "__metadata": spAppData.__metadata,
                            "CoordinatingSitesId": {
                                "__metadata": { "type": "Collection(Edm.Int32)"},
                                "results": facilities
                            },
                            "CoordinatingSitesLiaisonId":{
                                "__metadata": {"type": "Collection(Edm.Int32)"},
                                "results": liaisons
                            }                       
                        }     

                        spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};                    
                    }else{
                        //console.log("packaging empty data");
                        data = {
                            "__metadata": spAppData.__metadata,
                            "CoordinatingSitesId": {
                                "__metadata": { "type": "Collection(Edm.Int32)"},
                                "results": facilities
                            },
                            "CoordinatingSitesLiaisonId":{
                                "__metadata": {"type": "Collection(Edm.Int32)"},
                                "results": liaisons
                            }                                                 
                        }                        
                        spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};
                    }


                    spAppData.CoordinatingSitesId.results = facilities;
                    

                    //console.log("we are sending liaisons: " + liaisons + ", facilities: " + facilities);

                    sendREST("POST", spAppData.__metadata.uri, data, function(){
                        if(spsubsiteAppData != null){
                            sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
                                refreshDisplay("Facility");
                            }, "Merge");
                        }else{
                            refreshDisplay("Facility");
                        }
                    }, "Merge");
    //             }
    //         }
    // });
}

function insertPerson(){
    StartWorkflow("D9C79A8E-CD98-4176-9D11-9C8E91D62CFF", null);
    
    var inTable, capturedUser;

    if($('#initPerson').val() != "Please Select a User"){
        //check to see if person is in the sql table
        // if($('#initVA').is(':checked')){
        //     //person isn't in VA, needs to be added
        // }else{
        sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
            var foundUser = null;

            for(var j=0; j<returnedMembers.length; j++){
                if(returnedMembers[j].user.displayName == $('#initPerson').val()){
                    foundUser = returnedMembers[j];
                }
            }

            if(foundUser == null){
                sendREST("GET", restPath.concat("user"), null, function(returnedUsers){
                    for(var i=0; i<returnedUsers.length; i++){
                        //console.log("comparing: " + returnedUsers[i].displayName + " to " + $('#initPerson').val());
                        if(returnedUsers[i].displayName == $('#initPerson').val()){
                            sendPersonnelTable(returnedUsers[i]); 
                        }
                    }
                });                
            }else{
                sendPersonnelTable(foundUser.user, foundUser.study_MembersID);
            }
        });

        // }
    }else{
        insertWarning("You must first select a User before you can proceed.", "alert-warning");
    }
};

function sendPersonnelTable(foundUser, memberID){
    var data = {
        "study_MembersID": memberID,
        "user": foundUser,
        "vaUser": $('#initVA_0').is(':checked'),
        "teamMember": $('#initStudyTeam_0').is(':checked'),
        "memberRole": $('#initPersonRole').val(),
        "coiRequired": $('#initCOIReq_0').is(':checked'),
        "writePermissions": $('#initWritePerm_0').is(':checked'),
        "explaination": $('#initExplanation').val(),
        "notifications": $('#initNotify_0').is(':checked'),
        "activeMember": $('#initActivate_0').is(':checked')
    }
    //console.log("trying to send: " + JSON.stringify(data));
    //console.log("we are trying to add " + JSON.stringify(foundUser) + " with " + JSON.stringify(data));
    //sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+foundUser.usersID), data, function(){
    var AOMember = AOMemberCheck();
    if(AOMember == true) 
    {
       sendREST("POST", restPath.concat("study/"+assignedID+"/aomembers/"), data, function(){        
             refreshDisplay('Personnel');
        });

    }
    else
    {
        sendREST("POST", restPath.concat("study/"+assignedID+"/members/"), data, function(){        
            refreshDisplay('Personnel');
        });
    }
}

function removePerson(removeUserID){
    sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
       var foundDelUser = null;

        for(var j=0; j<returnedMembers.length; j++){
            if(returnedMembers[j].user.usersID == removeUserID){
                foundDelUser = returnedMembers[j];
            }
        }
        
        var data = {
            "study_MembersID": foundDelUser.study_MembersID,
            "user": foundDelUser.user,
            "teamMember": foundDelUser.teamMember,
            "memberRole": foundDelUser.memberRole,
            "coiRequired": foundDelUser.coiRequired,
            "writePermissions": foundDelUser.writePermissions,
            "explaination": foundDelUser.explaination,
            "notifications": foundDelUser.notifications,
            "activeMember": foundDelUser.activeMember

        }

        sendREST("POST", restPath.concat("study/"+assignedID+"/removemembers/"), data, function(){        
            refreshDisplay('Personnel');
        });
    });     
}

function updatePerson(updateUser){
    if(updateUser == null){
        updateUser = $('#initPerson').val();
    }

    sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
        for(var i=0; i<returnedMembers.length; i++){
            if(returnedMembers[i].user.displayName == updateUser){
                //console.log("found our user: " + returnedMembers[i].user.displayName);
                
                //name
                $('#initPerson').val(returnedMembers[i].user.displayName);

                //on study team
                if(returnedMembers[i].teamMember){
                    $('#initStudyTeam_0').attr('checked', 'checked');
                }else{
                    $('#initStudyTeam_1').attr('checked', 'checked');
                }

                //role
                $('#initPersonRole').val(returnedMembers[i].memberRole);

                //COI
                if(returnedMembers[i].coiRequired){
                    $('#initCOIReq_0').attr('checked', 'checked');
                }else{
                    $('#initCOIReq_1').attr('checked', 'checked');
                }

                //read/write
                if(returnedMembers[i].writePermissions){
                    $('#initWritePerm_0').attr('checked', 'checked');
                }else{
                    $('#initWritePerm_1').attr('checked', 'checked');
                }

                //user explination
                $('#initExplanation').val(returnedMembers[i].explaination);

                //notifications
                if(returnedMembers[i].notifications){
                    $('#initNotify_0').attr('checked', 'checked');
                }else{
                    $('#initNotify_1').attr('checked', 'checked');
                }

                //activate
                if(returnedMembers[i].activeMember){
                    $('#initActivate_0').attr('checked', 'checked');
                }else{
                    $('#initActivate_1').attr('checked', 'checked');
                }
            }
        }
    })
};

function returnChecked(boolean){
    if(boolean){
        return textCellHelper("td", "x");
    }

    return textCellHelper("td", "");
}

function deactivateUser(usersID){
    sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+usersID+"/deactivate"), null, function(){
        refreshDisplay("Personnel");
    });
}

function activateUser(usersID){
    sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+usersID+"/activate"), null, function(){
        refreshDisplay("Personnel");
    });
}

function AOMemberCheck(){ 
    var user;
    var AOMember = false;
     $.ajax({
        async: false,
        type: 'GET',
        url: siteUrl.concat("_api/Web/CurrentUser/Groups"),
        headers: {"accept": "application/json;odata=verbose"},
        dataType: 'json',
        success: function(json){
            user = json.d.results;
            for(var i=0; i<user.length; i++){
                if(user[i].Title.indexOf("AO") > -1){
                    AOMember = true;
                }
            }         
        }
    });
    return AOMember;
}

function removeAttachment(file, teamFolder){
    var data = [];
    var response = {};

    //console.log("looking to remove: " + file.split("-RAMS-")[0]);

    response = {
        "questionsID": file.split("-RAMS-")[0]
    };

    data.push(response);

    sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data, function(){
        sendREST("POST", siteUrl.concat("/_api/Web/GetFileByServerRelativeUrl('/sites/IRBApplications/Shared%20Documents/"+assignedID+"/"+teamFolder+"/"+file+"')"), null, function(){
            refreshDisplay("Files");
        }, "Delete");
    });
}

 function getAttachmentItem(itemID) {

        // Send the request and return the response.
        return jQuery.ajax({
            url: siteUrl.concat("/_api/Web/Lists/getByTitle('Shared Documents')/Items(" + itemID + ")"),
            type: "GET",
            headers: { "accept": "application/json;odata=verbose" }
        });
}

function updateAttachmentStatus(itemMetadata, docStatus) {

        // Define the list item changes. Use the FileLeafRef property to change the display name. 
        // For simplicity, also use the name as the title. 
        // The example gets the list item type from the item's metadata, but you can also get it from the
        // ListItemEntityTypeFullName property of the list.
        var item;
        var approvedDate = new Date();
        if (docStatus == "Approved"){
            item = {
            "__metadata": {"type": itemMetadata.type},
            "Status": docStatus,
            "DateApproved" : approvedDate
            };
        }
        else{
            
            item = {
            "__metadata": {"type": itemMetadata.type},
            "Status": docStatus
            };
        }

        // Send the request and return the promise.
        // This call does not return response content from the server.
        return jQuery.ajax({
            url: itemMetadata.uri,
            type: "POST",
            data: JSON.stringify(item),
            headers: {
                "X-RequestDigest": requestDigest,
                "content-type": "application/json;odata=verbose",
                "IF-MATCH": itemMetadata.etag,
                "X-HTTP-Method": "MERGE"
            }
        });
}
function updateAttachment() {
    var docStatus =  $('#status').find(':selected').val();
    var now = new Date();
    var attachmentItem = getAttachmentItem(currentAttachmentID);
    attachmentItem.done(function (listItem, status, xhr) {

            // Change the display name and title of the list item.
            var changeItem = updateAttachmentStatus(listItem.d.__metadata, docStatus);
            changeItem.done(function (data, status, xhr) {
                alert('Attachment status updated');
            });
            changeItem.fail(function (data, status, xhr) {
                alert('file uploaded failed:' + status);
            });
    });
    attachmentItem.fail(function (data, status, xhr) {
                alert('get attachment item failed' + status);
    });
    
    
    

}

function rerouteApp(childId){
    window.location.href("irb-applications-general.html?" + childId);
}

//Subscription id - Workflow subscription id
//list item id for which to start workflow. If site workflow, then send null for itemId
function StartWorkflow(subscriptionId, itemId) {
var ctx = SP.ClientContext.get_current();
var wfManager = SP.WorkflowServices.WorkflowServicesManager.newObject(ctx, ctx.get_web());
var subscription = wfManager.getWorkflowSubscriptionService().getSubscription(subscriptionId);
ctx.load(subscription, 'PropertyDefinitions');
ctx.executeQueryAsync(
   function (sender, args) {
       var params= new Object();
       //Find initiation data to be passed to workflow.
       var formData = subscription.get_propertyDefinitions()["FormData"];
       if (formData != null && formData != 'undefined' && formData != "") {
           var assocParams = formData.split(";#");
           for (var i = 0; i < assocParams.length; i++) {
               params[assocParams[i]] = subscription.get_propertyDefinitions()[assocParams[i]];
           }
       }
       if (itemId) {
           wfManager.getWorkflowInstanceService().startWorkflowOnListItem(guid, itemId, params);
       }
       else {
                params = { 
                Study_ID: assignedID,
                To: "Central IRB IRB Committee Coordinators", 
                Subject: "Personnel Has Changed",
                Body: "The Personnel Has Changed."

        };      
            wfManager.getWorkflowInstanceService().startWorkflow(subscription, params);
       }
       ctx.executeQueryAsync(
           function (sender, args) {
           },
           function (sender, args) {
               alert('Failed to run workflow');
           }
       );
   },
   function (sender, args) {
       alert('Failed to run workflow');
   }
);
}
