﻿Add-PSSnapin Microsoft.SharePoint.Powershell


$ArrayList = New-Object System.Collections.ArrayList



function formatOutput($listTable) {
  $listTable | Format-List
}

function getInternalName ($staticName, $list) {
    $list.Fields.TryGetFieldByStaticName($staticName).InternalName
    return;
}

function DeletedataFromAList ($days, $listUrl)
{
    #filter by days
    $count = $collListItems.Count;
    $date = get-date;
    $filterDays = $date.AddDays($days);

    #get a collection of ids
    $itemsToDelete = New-Object System.Collections.ArrayList
    
    #get site collection
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url

    $list = $w.GetListFromURL($listUrl)
    #get application list
    if($list -ne $null)
    {
        #Get all items in this list and save them to a variable
        $items = $list.items
        $itemCount = 1
        #Go through all items
        Write-Host Total Items before $items.Count -ForegroundColor Green
        foreach($item in $items)
        {
            if($item["Created"] -gt $filterDays)
            { 
                #add each item id to the delete list  
                Write-Host Add item# $itemCount  from the list for Study#: $item["Title"] on $item["Created"] -ForegroundColor Cyan                                 
                $itemsToDelete.Add($item.ID)
                #$item.Delete();
            }
            $itemCount ++;
        }
        #now start deleting those items
        foreach($itemToDelete in $itemsToDelete) {
            Write-Host Deleting item# $itemToDelete -ForegroundColor Cyan  
            $items.DeleteItemById($itemToDelete);                                                                                                    
        }
        $items.Update();
        $list.Update();
        Write-Host Total Items After $list.items.Count  -ForegroundColor Green
    }
}

#Delete workflow task list
$listUrl = $url + "/WorkflowTasks/AllItems.aspx"
DeleteDataFromAList -days -25 -listUrl $listUrl

#Delete Application list for older studies.
$listUrl = $url + "/Lists/Application/AllItems.aspx"
DeleteDataFromAList -days -500 -listUrl $listUrl

<#
$list = $w.Lists.TryGetList("Application")
$committeeList = $w.Lists.TryGetList("Committee List")
$facilityList = $w.Lists.TryGetList("Facility")
#>


