﻿
Add-PSSnapin Microsoft.SharePoint.PowerShell

$spAllList =  New-Object System.Collections.ArrayList
$listWfs =  New-Object System.Collections.ArrayList

$mainWeb = Get-SPWeb $siteUrl
$webs = $mainWeb.Webs

$spAllList.Add("Committee Calendar");
$spAllList.Add("Committee Members");
$spAllList.Add("Committee Roster");
$spAllList.Add("Committee Topics");
$spAllList.Add("Committee Workflow");
$spAllList.Add("CommitteeMinutes");
$spAllList.Add("Environment");

$spAllList.Add("IACUC Calendar");
$spAllList.Add("IACUC Documents");
$spAllList.Add("RCOChecklists");

$spAllList.Add("RDC Agenda");
$spAllList.Add("RDC Calendar");
$spAllList.Add("RDC Documents");
$spAllList.Add("Reviews");

foreach ($w in $webs) {
  foreach($listName in $spAllList) {
    $SPList  =$w.Lists.TryGetList($listName)
    $workflowAssociations = $SPList.WorkflowAssociations;
    $listWfs.Clear();
    #store which ones to be removed in a collection
    if($workflowAssociations.Count  -gt 0)
    {
        foreach($wf in $workflowAssociations)
        {
            $listWfs.Add($wf) 
            #Write-Host "List:" $SPList.EntityTypeName  ", WF-Name:" $wf.Name ", Status (isEnabled):" $wf.Enabled ", Status (isGloballyEnabled):" $wf.GloballyEnabled
        }
    }
    
    #remove all listed in the collection    
    foreach($wfItem in $listWfs)
    {
        $SPList.RemoveWorkflowAssociation($wfItem);
        Write-Host "Removed-List:" $SPList.EntityTypeName  ", WF-Name:" $wf.Name ", Status (isEnabled):" $wf.Enabled ", Status (isGloballyEnabled):" $wf.GloballyEnabled            
        $SPList.Update();
    }
    
  }
}

<#
$xWeb = Get-Spweb $siteUrl
Enable-SPFeature -Identity "Add To SRS AgendaListInstances" -Url $siteUrl 
$spFeature = Get-SPFeature -Web $xWeb -Identity "Add To IACUC Agenda.wsp"
Disable-SPFeature -Identity $spFeature.Id -Url $w.Url -Force   
Uninstall-SPUserSolution -Identity "Add To IACUC Agenda.wsp" -Site $xWeb.Site       
Remove-SPUserSolution -Identity "Add To IACUC Agenda.wsp" -Site $xWeb.Site    
$spFeature.DisplayName
#>