#PowerShell to create new ApplicationFacilityLookup List with new list fields in all subsites , not in Root
if ((Get-PSSnapin "Microsoft.SharePoint.PowerShell" -ErrorAction SilentlyContinue) -eq $null)
{
    Add-PSSnapin "Microsoft.SharePoint.PowerShell"
}
#Begin Creating new sub sites ApplicationFacilityLookup list Here 
# use Get-SPWebApplication http://localhost or -Identity "http://va.ww.idev.ram/msp.va.gov/sites/IRBApplications" for testing in DEV
#$siteUrl = "https://vaww.idev.ram.msp.va.gov/sites/IRBApplications"
$w = Get-SPWeb $siteUrl
$webApp = $siteURL


    foreach($web in $w.Webs)
    {
        #Create New List in Subsites
        $web.Lists.Add("ApplicationFacilityLookup", "ApplicationFacilityLookup", 
            $web.ListTemplates["Custom List"]); 

        #ADD LIST COLUMNS FROM SITE COLUMNS
        Write-Host "Creating New Column Fields in New List"

        #Add ApplicationRecordID Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("ApplicationRecordID", [Microsoft.SharePoint.SPFieldType]::Number, $true)
        $myNewChoiceField = $myList.Fields["ApplicationRecordID"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()

        #Create Study_ID Column
        $myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("Study_ID", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["Study_ID"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.Type="Text"
		$myNewChoiceField.update()
        
        #Add StudyIDLink Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("StudyIDLink", [Microsoft.SharePoint.SPFieldType]::Calculated, $true)
        $myNewChoiceField = $myList.Fields["StudyIDLink"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()
        $CalculatedColumnName = "StudyIDLink"
        $CalculatedCol = $myList.Fields.GetField($CalculatedColumnName)
        $CalculatedCol.Formula="=CONCATENATE(""<div><a href='"",""/sites/IRBApplications/SiteAssets/irb-applications-general.html?"",Study_ID,"""",""'>"",Study_ID,""</a></div>"")"
        $CalculatedCol.OutputType="Number"
        $CalculatedCol.Update()		

        #Add Application Status Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("Application Status", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["Application Status"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()

        #Add Study Title Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("Study Title", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["Study Title"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()		

        #Add Facility Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("Facility", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["Facility"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()
		
		#Add Proxy Facility Column 
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("Proxy Facility", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["Proxy Facility"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()
		
		#Add MovedToFacility Column
		$myList = $web.Lists["ApplicationFacilityLookup"]
        $fieldID = $myList.Fields.Add("MovedToFacility", [Microsoft.SharePoint.SPFieldType]::Text, $true)
        $myNewChoiceField = $myList.Fields["MovedToFacility"]
		$myNewChoiceField.required = $false
		$myNewChoiceField.update()

		Write-Host "ApplicationFacilityLookup List has been added to the sub-site:  $web";
		$web.Dispose();

    }

Write-Host "All ApplicationFacilityLookup Subsite Lists Created"