Add-PSSnapin Microsoft.SharePoint.Powershell

function GetAllWebs($url)
{
    #try
    #{
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
    
        if($w.Webs.Count -gt 0)
        {
            foreach($web in $w.Webs)
            {
               CreateApprovedSiteColumn $web;
             }
        }
    #}
    #catch
    #{
    #    Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    #}   
}


 function CreateApprovedSiteColumn($web) {
    #CREATE SITE COLUMNS
    echo "CREATING SITE COLUMNS"
    
	# GET THE LISTS
	$myList = $web.Lists["ApplicationFacilityLookup"];

	#Where the Source List for Lookup Exists
	
	$ParentWebURL=$web.Url
	$ParentListName="ApplicationFacilityLookup"
	$ParentLookupColumnName="Approved Applications"
	
	#Where the Lookup Site column Going to get created
	$ChildWebURL=$web.Url
	$ChildLookupColumnName="ApprovedApplicationsLookup"
	
	#Get the Parent and Child Webs and List
	
	$ParentWeb = Get-SPWeb $ParentWebURL
	$ParentList = $ParentWeb.Lists[$ParentListName]
	$ChildWeb = Get-SPWeb $ChildWebURL
	$ChildLookupColumnName="ApprovedApplicationsLookup"
	if(!$ChildWeb.Fields.ContainsFieldWithStaticName($ChildLookupColumnName))
	{
	    #Add Lookup Field
	
	    $ChildLookupColumn = $ChildWeb.Fields.AddLookup($ChildLookupColumnName,$ParentList.id,$False)
	    $ChildWeb.Update()

	    $ChildLookupColumn = $ChildWeb.Fields[$ChildLookupColumnName]
	
	    #Setup lookup Field property
	
	    $ChildLookupColumn.LookupWebId = $ParentWeb.ID
	
	    $ChildLookupColumn.LookupField = $ParentList.Fields[$ParentLookupColumnName].InternalName
	
	    $ChildLookupColumn.AllowMultipleValues=$true
	
	   	$ChildLookupColumn.Group="RAMS IRB" 
        $ChildLookupColumn.Title="Approved Applications Lookup"

	    $ChildLookupColumn.update()
        write-host "Lookup field added successfully to the $childWeb !" -f green
		  
	}
	else
	{
	    write-host "Field Exists already on the $childWeb !" -f red
	} 
    
	#CREATE LIST COLUMNS FROM SITE COLUMNS
	echo "CREATING LIST COLUMNS"
		
	$calendarName="RDC Calendar"
		
	# GET THE LISTS	    
	$myList = $web.Lists[$calendarName];
	if ($myList -ne $null) {
	    if (!$myList.Fields.ContainsFieldWithStaticName($ChildLookupColumnName)) {
            if($web.Fields.TryGetFieldByStaticName($ChildLookupColumnName) -ne $null)
            {
			    $listField=$web.Fields.TryGetFieldByStaticName($ChildLookupColumnName)
			    $myList.Fields.Add($listField)
			    $myList.Update()
                write-host "Lookup field added successfully to the $myList " -f green
            }
            else
            {
                Write-Host "Site Column: $ChildLookupColumnName  Does not exist" 
            }				

		} 
	} 

}

#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)
   