function global:New-SPGroup {
#Parameters that the script offers out to use, 
 [CmdletBinding()]
 Param(
 [Microsoft.SharePoint.PowerShell.SPWebPipeBind]
 [string]$SiteCollection,
 [string]$ADGroupName,
 [string]$SPGroupName,
 [string]$SPGroupDescription,
 [string]$SPGroupPermission
 )

#Required variabales for dev or single item runs, remove # and highlight from here down to above CSV section in Powershell ISE
#$SiteCollection = "https://vaww.idev.ram.msp.va.gov/sites/IRBApplications"
#$ADGroupName = "domain\adgroup"
#$SPGroupName = "My Test Group A1"
#$SPGroupDescription = "Test Group A1's Description" #Note: do not use" - " in description, i.e. space hyphen space
#$SPGroupPermission = "Read"
 
#Start of script
$site = Get-SPWeb $SiteCollection

#Check if the group already exists
if ($site.SiteGroups[$SPGroupName] -eq $null)
{

#Create the SharePoint Group - Group Name, Group Owner, Group Member, Group Description. Can't add AD group yet...
$NewSPGroup = $site.SiteGroups.Add($SPGroupName, $site.CurrentUser, $site.CurrentUser, $SPGroupDescription)
$site.AssociatedGroups.Add($site.SiteGroups["$SPGroupName"]);
$NewSPAccount = $site.SiteGroups["$SPGroupName"]

#Assign the Group permission
$GroupAssignment = New-Object Microsoft.SharePoint.SPRoleAssignment($NewSPAccount)
$GroupRole = $site.RoleDefinitions["$SPGroupPermission"]
$GroupAssignment.RoleDefinitionBindings.Add($GroupRole)
$site.RoleAssignments.Add($GroupAssignment)

}
$site.Dispose()
}

#$SiteUrl = "http://vaww.idev.ram.msp.va.gov/sites/IRBApplications"

$description = " "
$permissionLevel = "Edit"

$RCO = "RCO Group"


 New-SPGroup -Site $SiteUrl -SPGroupName $RCO -SPGroupDescription $RCO -SPGroupPermission $permissionLevel;