Add-PSSnapin Microsoft.SharePoint.Powershell

function GetAllWebs($url)
{
  
    try
    {
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
        if($w.Webs.Count -gt 0)
        {
            foreach($web in $w.Webs)
            {
              DeleteSRSDocumentLibrary $web;
              CreateSRSDocumentLibrary $web;
            }
        }
    }
    catch
    {
        Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    }   
}

function DeleteSRSDocumentLibrary($web) 
{
  $list = $web.Lists.TryGetList("SRS Documents")
    if($list -ne $null)
    {
        # The list already exists
        $ListToDeleteName = "SRS Documents"
	    echo "Deleting List"   $ListToDeleteName
 
	    #Get Web and List objects
	    $list = $web.Lists[$ListToDeleteName]
	
	    #Reset the "Allow Deletion" Flag
	    $list.AllowDeletion = $true
       
	    $list.Update()
	    $list.Delete()
    }	
}

function CreateSRSDocumentLibrary($web) 
{       
	echo "This SRS Is created" $web.url
	$SPTemplate = [Microsoft.Sharepoint.SPListTemplateType]::DocumentLibrary
	$web.Lists.Add("SRSDocuments","SRSDocuments",$SPTemplate)
	       
	$list = $web.Lists.TryGetList("SRSDocuments")

	if($list -ne $null)
	{
		$list.Title="SRS Documents"
		$list.Update()
	}
}

#This is to test the driver contains a $siteUrl
#$siteUrl="http://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)