Add-PSSnapin Microsoft.SharePoint.Powershell

function GetAllWebs($url)
{
    #try
    #{
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Cyan
        if($w.Webs.Count -gt 0)
        {
            foreach($web in $w.Webs)
            {
                    FixCommitteeCalendarFieldsFromList $web
			}
        }
    #}
    #catch
    #{
    #    Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    #}   
}

 function FixCommitteeCalendarFieldsFromList($web) {      
   $calendarName="Committee Calendar"
    
	$list = $web.Lists[$calendarName];  

    if ($list -ne $null) 
    {
        #Create the new field
	    if ($list.Fields.ContainsField("Application Study Lookup")) {
			CreateLookupSiteColumn $web $web.url "Committee Calendar" "Application Study Lookup" "ApplicationStudyLookup" $childFieldInternalName, $web.url "Committee Topics" "Study Title" $true "RAMS IRB"
		#copy the data from the old field to the new field 
		#TODO??
		
		#delete the old field
		#TODO??
		}
	}
 }
 
function CreateLookupSiteColumn ($web, $childWebUrl, $childListName, $childField, $childFieldInternalName, $parentWebUrl, $parentListName, $parentLookupChildName, $allowMultiValues, $groupName) {
 	#CREATE SITE COLUMNS
    Write-Host "CREATING LOOKUP COLUMN $childField on list $childListName from $parentListName $parentLookupChildName" -foregroundcolor white
    
	# GET THE LISTS
	$myList = $web.Lists[$childListName];

	#Where the Source List for Lookup Exists
	
	$ParentWebURL=$parentweb
	$ParentListName=$parentListName
	$ParentLookupColumnName=$parentLookupChildName
	
	
	#Where the Lookup Site column Going to get created
	$ChildWebURL=$childWebUrl
	$ChildLookupColumnName=$newField
	$ChildLookupColumnNameInternal=$newFieldInternalName
	
	#Get the Parent and Child Webs and List
	
	$ParentWeb = Get-SPWeb $ParentWebURL
	$ParentList = $ParentWeb.Lists[$ParentListName]
	$ChildWeb = Get-SPWeb $ChildWebURL
	
	if(!$ChildWeb.Fields.ContainsField($ChildLookupColumnNameInternal))
	{
	    #Add Lookup Field
	
	    $ChildLookupColumn = $ChildWeb.Fields.AddLookup($ChildLookupColumnNameInternal,$ParentList.id,$False)
	    $ChildWeb.Update()

	    $ChildLookupColumn = $ChildWeb.Fields[$ChildLookupColumnName]
	
	    #Setup lookup Field property
	
	    $ChildLookupColumn.LookupWebId = $ParentWeb.ID
	
	    $ChildLookupColumn.LookupField = $ParentList.Fields[$ParentLookupColumnName].InternalName
	
	    $ChildLookupColumn.AllowMultipleValues=$allowMultiValues
	
	   	$ChildLookupColumn.Group=$groupName 
        $ChildLookupColumn.Title=$ChildLookupColumnName

	    $ChildLookupColumn.update()
	
	    write-host "  Lookup field added successfully!" -f green
	  
		#CREATE LIST COLUMNS FROM SITE COLUMNS
        Write-Host "CREATING LIST COLUMN $childField on list $childListName from $parentListName $parentLookupChildName" -foregroundcolor white
		
	    $calendarName=$childListName
		
	    # GET THE LISTS
		$myList = $web.Lists[$calendarName];
		
	    if (!$myList.Fields.ContainsField($ChildLookupColumnNameInternal)) {
	        write-host "  Add $ChildLookupColumnNameInternal to Committee Calendar" -f green
            if($web.Fields.TryGetFieldByStaticName($ChildLookupColumnNameInternal) -ne $null)
            {
			    $listField=$web.Fields.GetFieldByInternalName($ChildLookupColumnNameInternal)
			    $myList.Fields.Add($listField)
			    $myList.Update()
            }
            else
            {
                Write-Host "  Site Column: $ChildLookupColumnNameInternal  Does not exist" -f yellow
            }
		}
	
	}
	else
	{
	    write-host "  Field Exists already!" -f red
	} 
	
}

 
#This is to test the driver contains a $siteUrl
$siteUrl="https://vaww.tst.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)
