Add-PSSnapin Microsoft.SharePoint.Powershell

$facilities = @{
}

function GetAllWebs($url)
{
    #try
    #{
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
	        if($w.Webs.Count -gt 0)
	        {
	            foreach($web in $w.Webs)
	            {
			    	FixCalendarOrder $web       
	            }
	        }
        			 	 
    #}
    #catch
    #{
     #   Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    #}   
 } 
    
	 function FixCalendarOrder($subweb) 
	 {
	
        $list = $subweb.Lists.TryGetList("Committee Calendar")
        $contentType = "Event"
        $ct = $list.ContentTypes[$contentType] 

        if($list -ne $null)
        {
            Write-Host "Fixing Order for Committee Calendar" -ForegroundColor Cyan 
            $contentType = "Event"
            $newFieldOrder = @("Title", "EventDate", "EndDate", "Location", "fAllDayEvent", "fRecurrence","CommitteeAttendees",  "ParticipantsPicker","Administrative_x0020_Items", "SubmittedApplicationLookup", "CommitteeCalendarMeetingMinuteLo", "Decision", 
            "Deliberation")
   			
   		   if ($list.Fields.ContainsFieldWithStaticName("SubmittedApplicationLookup")) {
	            $ApplicationsStudyLookupField = $list.Fields.TryGetFieldByStaticName("SubmittedApplicationLookup");
	            $ApplicationsStudyLookupField.ShowInEditForm=$True;
	            $ApplicationsStudyLookupField.ShowInNewForm=$True;
	            $ApplicationsStudyLookupField.Update($true)
	            $list.Update($true)
	        }
      		if ($list.Fields.ContainsFieldWithStaticName("CommitteeCalendarMeetingMinuteLookup")) {
	            $ApplicationsStudyLookupField = $list.Fields.TryGetFieldByStaticName("CommitteeCalendarMeetingMinuteLookup");
	            $ApplicationsStudyLookupField.ShowInEditForm=$True;
	            $ApplicationsStudyLookupField.ShowInNewForm=$True;
	            $ApplicationsStudyLookupField.Update($true)
	            $list.Update($true)
	        }        	
      		if ($list.Fields.ContainsFieldWithStaticName("Decision")) {
	            $ApplicationsStudyLookupField = $list.Fields.TryGetFieldByStaticName("Decision");
	            $ApplicationsStudyLookupField.ShowInEditForm=$True;
	            $ApplicationsStudyLookupField.ShowInNewForm=$True;
	            $ApplicationsStudyLookupField.Update($true)
	            $list.Update($true)
	        }        	
      		if ($list.Fields.ContainsFieldWithStaticName("Deliberation")) {
	            $ApplicationsStudyLookupField = $list.Fields.TryGetFieldByStaticName("Deliberation");
	            $ApplicationsStudyLookupField.ShowInEditForm=$True;
	            $ApplicationsStudyLookupField.ShowInNewForm=$True;
	            $ApplicationsStudyLookupField.Update($true)
	            $list.Update($true)
	        }        	
      		if ($list.Fields.ContainsFieldWithStaticName("TaxKeyword")) {
	            $ApplicationsStudyLookupField = $list.Fields.TryGetFieldByStaticName("TaxKeyword");
	            $ApplicationsStudyLookupField.ShowInEditForm=$False;
	            $ApplicationsStudyLookupField.ShowInNewForm=$False;
                $ApplicationsStudyLookupField.Hidden = $True;
	            $ApplicationsStudyLookupField.Update($true)
	            $list.Update($true)
	        }            	$ct = $list.ContentTypes[$contentType]
            $ct.FieldLinks.Reorder($newFieldOrder)
            $ct.Update() 
            $list.Update()
            $subweb.Update()
        }	
        
        $list = $subweb.Lists.TryGetList("RDC Calendar")
        if($list -ne $null)
        {
            Write-Host "Fixing Order for RDC Calendar" -ForegroundColor Cyan
            $rcontentType = "Event"
            $newFieldOrder = @("Title", "EventDate", "EndDate", "Location", "fAllDayEvent", "fRecurrence","CommitteeAttendees",  "ParticipantsPicker","Administrative_x0020_Items",  "ApprovedApplicationsLookup", "RDCCalendarMeetingMinuteLookup", "Decision", 
            "Deliberation")

           if ($list.Fields.ContainsField("TaxKeyword")) {
                $enterpriseField = $list.Fields.GetFieldByInternalName("TaxKeyword")
                $list.Fields.Delete($enterpriseField)   
                #$enterpriseField.Update($true)
                $list.Update($true)
           }

              if ($list.Fields.ContainsField("Description")) {
	            $ct = $list.ContentTypes[$contentType] 
	            $ct.FieldLinks["Description"].Hidden = $True
	            $ct.FieldLinks.Reorder($newFieldOrder)
	            $ct.Update() 
	            $list.Update()
           }
             

             if ($list.Fields.ContainsField("EventAdministrativeItems")) {
	             $EventAdministrativeItemsField = $list.Fields.GetFieldByInternalName("EventAdministrativeItems");
	             $EventAdministrativeItemsField.ShowInEditForm=$false;
	             $EventAdministrativeItemsField.ShowInNewForm=$false;
	             $EventAdministrativeItemsField.Update($true)
	             $list.Update($true)
             }

             if ($list.Fields.ContainsField("EventAttendees")) {
	             $EventAttendeesField = $list.Fields.GetFieldByInternalName("EventAttendees");
	             $EventAttendeesField.ShowInEditForm=$false;
	             $EventAttendeesField.ShowInNewForm=$false;
	             $EventAttendeesField.Update($true)
	             $list.Update($true)
			 }
             
             if ($list.Fields.ContainsField("EventCommitteeAttendees")) {
	             $CommitteeAttendeesField  = $list.Fields.GetFieldByInternalName("EventCommitteeAttendees");
	             $CommitteeAttendeesField.ShowInEditForm=$false;
	             $CommitteeAttendeesField.ShowInNewForm=$false;
	             $CommitteeAttendeesField.Update($true)
	             $list.Update($true)
             }

             if ($list.Fields.ContainsField("EventCommitteeAttendees")) {
	             $DecisionField  = $list.Fields.GetFieldByInternalName("EventCommitteeAttendees");
	             $DecisionField.ShowInEditForm=$false;
	             $DecisionField.ShowInNewForm=$false;
	             $DecisionField.Update($true)
	             $list.Update($true)
             }
                          
            $contentType = "Event"
            $newFieldOrder = @("Title", "EventDate", "EndDate", "Location", "fAllDayEvent", "fRecurrence","CommitteeAttendees",  "ParticipantsPicker","Administrative_x0020_Items",  "ApprovedApplicationLookup", "MeetingMinutesLookup", "Decision", 
            "Deliberation"
            )
           if ($list.Fields.ContainsField("Description")) {
	            $ct = $list.ContentTypes[$contentType] 
	            $ct.FieldLinks["Description"].Hidden = $True
	            $ct.FieldLinks.Reorder($newFieldOrder)	            
	            $list.Update()
           }

          if ($list.Fields.ContainsField("Category")) {
	            $categoryfield=$list.Fields["Category"]
	            $categoryfield.ShowInNewForm=$false 
	            $categoryfield.ShowInEditForm=$false
	            $categoryfield.Update($true)
	            $list.Update()
       	 }
       
      	  if ($list.Fields.ContainsField("ApplicationsLookup")) {
      		$applicationsField=$list.Fields["ApplicationsLookup"]
            $applicationsField.ShowInNewForm=$false 
            $applicationsField.ShowInEditForm=$false
            $applicationsField.Update($true)
            $list.Update()
      	  }
      	  
      	  if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
      	    $approvedRDCApplicationLookup=$list.Fields["ApprovedRDCApplicationLookup"]
            $approvedRDCApplicationLookup.ShowInNewForm=$false 
            $approvedRDCApplicationLookup.ShowInEditForm=$false
            $approvedRDCApplicationLookup.Update($true)
            $list.Update()
      	  }    
      }
          
        $list = $subweb.Lists.TryGetList("IACUC Calendar")
        if($list -ne $null)
        {
     
            Write-Host "Fixing Order for IACUC Calendar" -ForegroundColor Cyan 
            $contentType = "Event"
            $newFieldOrder = @("Title", "EventDate", "EndDate", "Location", "fAllDayEvent", "fRecurrence","CommitteeAttendees",  "ParticipantsPicker","Administrative_x0020_Items", "TaxKeyword", "SubmittedApplicationLookup", "IACUCCalendarMeetingMinuteLookup", "Decision", 
            "Deliberation"
            )
              
           if ($list.Fields.ContainsField("TaxKeyword")) {
                $enterpriseField = $list.Fields.GetFieldByInternalName("TaxKeyword")
                $list.Fields.Delete($enterpriseField)   
           }

           if ($list.Fields.ContainsField("Description")) {
	            $ct = $list.ContentTypes[$contentType] 
	            $ct.FieldLinks["Description"].Hidden = $True
	            $ct.FieldLinks.Reorder($newFieldOrder)
	            $ct.Update() 
	            $list.Update()
           }

          if ($list.Fields.ContainsField("Category")) {
	            $categoryfield=$list.Fields["Category"]
	            $categoryfield.ShowInNewForm=$false 
	            $categoryfield.ShowInEditForm=$false
	            $categoryfield.Update($true)
	            $list.Update()
       	 }
       
      	  if ($list.Fields.ContainsField("ApplicationsLookup")) {
      		$applicationsField=$list.Fields["ApplicationsLookup"]
            $applicationsField.ShowInNewForm=$false 
            $applicationsField.ShowInEditForm=$false
            $applicationsField.Update($true)
            $list.Update()
      	  }
      	  
      	  if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
      	    $approvedRDCApplicationLookup=$list.Fields["ApprovedRDCApplicationLookup"]
            $approvedRDCApplicationLookup.ShowInNewForm=$false 
            $approvedRDCApplicationLookup.ShowInEditForm=$false
            $approvedRDCApplicationLookup.Update($true)
            $list.Update()
      	  }
            

        }	

        $list = $subweb.Lists.TryGetList("SRS Calendar")
        if($list -ne $null)
        {
            Write-Host "Fixing Order for SRS Calendar" -ForegroundColor Cyan
            $contentType = "Event"
            $newFieldOrder = @("Title", "EventDate", "EndDate", "Location", "fAllDayEvent", "fRecurrence","EventCommitteeAttendees",  "EventAttendees","EventAdministrativeItems", "TaxKeyword", "SubmittedApplicationLookup", "SRSCalendarMeetingMinuteLookup", "Decision", 
            "Deliberation")
           
             
           if ($list.Fields.ContainsField("TaxKeyword")) {
                $enterpriseField = $list.Fields.GetFieldByInternalName("TaxKeyword")
                $list.Fields.Delete($enterpriseField)   
           }
           
           
           if ($list.Fields.ContainsField("Description")) {
	            $ct = $list.ContentTypes[$contentType] 
	            $ct.FieldLinks["Description"].Hidden = $True
	            $ct.FieldLinks.Reorder($newFieldOrder)
	            $ct.Update() 
	            $list.Update()
           }

          if ($list.Fields.ContainsField("Category")) {
	            $categoryfield=$list.Fields["Category"]
	            $categoryfield.ShowInNewForm=$false 
	            $categoryfield.ShowInEditForm=$false
	            $categoryfield.Update($true)
	            $list.Update()
       	 }
       
      	  if ($list.Fields.ContainsField("ApplicationsLookup")) {
      		$applicationsField=$list.Fields["ApplicationsLookup"]
            $applicationsField.ShowInNewForm=$false 
            $applicationsField.ShowInEditForm=$false
            $applicationsField.Update($true)
            $list.Update()
      	  }
      	  
      	  if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
      	    $approvedRDCApplicationLookup=$list.Fields["ApprovedRDCApplicationLookup"]
            $approvedRDCApplicationLookup.ShowInNewForm=$false 
            $approvedRDCApplicationLookup.ShowInEditForm=$false
            $approvedRDCApplicationLookup.Update($true)
            $list.Update()
      	  }
            

        }	
       
     
	}
	
#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)
   
