﻿Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue   
   
 #Variables   
 $SiteURL = getSiteURL   
 
 
    $facilityList = @(
        "Asheville",
        "Central IRB",
        "Josh Template Testing",
        "Miami",
        "New Orleans",
        "St Louis",
        "Localsite2" 
    );
 #Get site and Group objects   
 $Site = Get-SPSite $SiteURL   

 #for each facility change the user groups to new names.
 foreach($key in $facilityList) {
    $Groups = $Site.RootWeb.SiteGroups
    foreach ($Group in $Groups) {
     if($Group.Name.Contains($key))   
         {   
            #get new group name             
             Write-host $Group.ID: $Group.Name -ForegroundColor Cyan 
         }   
    }  
 }
 #for each facility change the ownership to local site administrator
     
 #dispose site object   
 $site.Dispose()  


function getSiteURL {
    $site = Get-SPSite | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url
    return $url
}