Add-PSSnapin Microsoft.SharePoint.Powershell

$facilities = @{
}

function GetAllWebs($url)
{
    #try
    #{
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
	        if($w.Webs.Count -gt 0)
	        {
	         
	            foreach($web in $w.Webs)
	            {
				 	RegenerateCalendarForms $web "Committee Calendar"
				 	RegenerateCalendarForms $web "RDC Calendar"
            		RegenerateCalendarForms $web "IACUC Calendar"
            		RegenerateCalendarForms $web "SRS Calendar"
	            }
	        }
        			 	 
    #}
    #catch
    #{
    #    Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    #}   
 } 
    

       
function RegenerateCalendarForms ($web, $listname) {

$list = $web.lists[$listname]

	if ($list -ne $null) {
		$files = $list.rootfolder.files
		
		#---------------------------- Delete Forms ----------------------
		
		$form1 = $list.RootFolder.files | ?{$_.url -match "dispform.aspx"}
		
		$form2 = $list.RootFolder.files | ?{$_.url -match "editform.aspx"}
		
		$form3 = $list.RootFolder.files | ?{$_.url -match "newform.aspx"}
		
		$form2.delete()
		$form1.delete()
		$form3.delete()
		
		$list.update()
		
		# --------------------------recreating --------------------------------
		
		$editformurl = $list.RootFolder.ServerRelativeUrl + "/editform.aspx"
		$dispformurl = $list.RootFolder.ServerRelativeUrl + "/Dispform.aspx"
		$newformurl = $list.RootFolder.ServerRelativeUrl + "/NewForm.aspx"
		
		$dispform = $files.add($dispformurl, [Microsoft.SharePoint.SPTemplateFileType]::FormPage)
		$editform = $files.add($editformurl, [Microsoft.SharePoint.SPTemplateFileType]::FormPage)
		$newform = $files.add($newformurl, [Microsoft.SharePoint.SPTemplateFileType]::FormPage)
		
		$wpm = $editform.GetLimitedWebPartManager([System.Web.UI.WebControls.WebParts.PersonalizationScope]::Shared)
		$wpm2 = $dispform.GetLimitedWebPartManager([System.Web.UI.WebControls.WebParts.PersonalizationScope]::Shared)
		$wpm3 = $newform.GetLimitedWebPartManager([System.Web.UI.WebControls.WebParts.PersonalizationScope]::Shared)
		
		$lfw1 = new-object ([Microsoft.SharePoint.WebPartPages.ListFormwebpart])
		$lfw2 = new-object ([Microsoft.SharePoint.WebPartPages.ListFormwebpart])
		$lfw3 = new-object ([Microsoft.SharePoint.WebPartPages.ListFormwebpart])
		
		$ilist1 = [Microsoft.SharePoint.WebPartPages.IListWebPart]($lfw1)
		$ilist2 = [Microsoft.SharePoint.WebPartPages.IListWebPart]($lfw2)
		$ilist3 = [Microsoft.SharePoint.WebPartPages.IListWebPart]($lfw3)
		
		$ilist1.ListId = $list.id
		$ilist1.PageType = [Microsoft.SharePoint.PAGETYPE]::PAGE_EDITFORM;
		
		$ilist2.ListId = $list.id
		$ilist2.PageType = [Microsoft.SharePoint.PAGETYPE]::PAGE_DISPLAYFORM;
		
		$ilist3.ListId = $list.id
		$ilist3.PageType = [Microsoft.SharePoint.PAGETYPE]::PAGE_NEWFORM;
		
		$wpm.AddWebPart($lfw1, "Main", 1)
		$wpm2.AddWebPart($lfw2, "Main", 1) 
		$wpm3.AddWebPart($lfw3, "Main", 1)
		
		
		$list.DefaultDisplayFormUrl = $dispformurl
		$list.DefaultEditFormUrl = $editformurl 
		$list.DefaultNewFormUrl = $newformurl
		
		$list.update()
	}
}    

#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)
   
