Add-PSSnapin Microsoft.SharePoint.Powershell

function GetAllWebs($url)
{
    #try
    #{
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
        if($w.Webs.Count -gt 0)
        {
            foreach($web in $w.Webs)
            {
                    DeleteCommitteeFieldsFromList $web
                    DeleteRDCFieldsFromList $web
                    DeleteIACUCFieldsFromList $web;
                    DeleteSRSFieldsFromList $web                     
			  }
        }
    #}
    #catch
    #{
    #    Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    #}   
}

 function DeleteCommitteeFieldsFromList($web) {      
   $calendarName="Committee Calendar"
    
	$list = $web.Lists[$calendarName];  

    if ($list -ne $null) 
    {

	    if ($list.Fields.ContainsFieldWithStaticName("ApplicationStudyLookup_x003a_Study_x0020_Title")) {
	        $field = $list.Fields.TryGetFieldByStaticName("ApplicationStudyLookup_x003a_Study_x0020_Title") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsFieldWithStaticName("ApplicationStudyLookup")) {
	        $field = $list.Fields.TryGetFieldByStaticName("ApplicationStudyLookup") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsField("ApplicationsLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApplicationsLookup") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsField("MeetingMinutesLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("MeetingMinutesLookup") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsField("RDCMinuteLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("RDCMinuteLookup") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsField("Approved Application Lookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedApplicationLookup0") 
	        $list.Fields.Delete($field)   
	    }

	    if ($list.Fields.ContainsField("ApprovedApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }

		if ($list.Fields.ContainsFieldWithStaticName("ApprovedApplicationLookup")) {
	        $field = $list.Fields.TryGetFieldByStaticName("ApprovedApplicationLookup") 
            if($field -ne $null) {
	            $list.Fields.Delete($field)   
            }
	    }

		if ($list.Fields.ContainsFieldWithStaticName("ApplicationStudyLookup1")) {
	        $field = $list.Fields.TryGetFieldByStaticName("ApplicationStudyLookup1") 
            if($field -ne $null) {
	            $list.Fields.Delete($field)   
            }
	    }
	    
	    if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedRDCApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }	     	
	    $list.Update($true)
    }
   
 }

 function DeleteFieldByStaticName ($staticName)
 {
    #future
 }
 
  function DeleteRDCFieldsFromList($web) {      
   $calendarName="RDC Calendar"
    
   $list = $web.Lists[$calendarName];  
 	if ($list -ne $null) 
    {
	    if ($list.Fields.ContainsField("ApplicationStudyLookup_x003A_Stu")) {
	        $field = $list.Fields.GetFieldByInternalName("ApplicationStudyLookup_x003A_Stu") 
	        $list.Fields.Delete($field)   
	    }
	
		if ($list.Fields.ContainsField("Application_x0020_Study_x0020_Lo")) {
	        $field = $list.Fields.GetFieldByInternalName("Application_x0020_Study_x0020_Lo") 
	        $list.Fields.Delete($field)   
	    }
	        
	    if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedRDCApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }
	 	if ($list.Fields.ContainsField("RDCMinuteLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("RDCMinuteLookup") 
	        $list.Fields.Delete($field)   
	    }
	    $list.Update($true)
    }
   
 }
    
 function DeleteIACUCFieldsFromList($web) {      
    $calendarName="IACUC Calendar"
    
	$list = $web.Lists[$calendarName];  
	
	if ($list -ne $null) 
    {
	    if ($list.Fields.ContainsField("ApplicationStudyLookup_x003A_Stu")) {
	        $field = $list.Fields.GetFieldByInternalName("ApplicationStudyLookup_x003A_Stu") 
	        $list.Fields.Delete($field)   
	    }
	
		if ($list.Fields.ContainsField("Application_x0020_Study_x0020_Lo")) {
	        $field = $list.Fields.GetFieldByInternalName("Application_x0020_Study_x0020_Lo") 
	        $list.Fields.Delete($field)   
	    }
	    
	    if ($list.Fields.ContainsField("RDCMinuteLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("RDCMinuteLookup")
	        $list.Fields.Delete($field)   
	    }
	    
	     if ($list.Fields.ContainsField("IACUCMinuteLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("IACUCMinuteLookup") 
	        $list.Fields.Delete($field)   
	    }

	     if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedRDCApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }

	     if ($list.Fields.ContainsField("IACUCApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("IACUCApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }

	     if ($list.Fields.ContainsField("ApprovedApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }
	     if ($list.Fields.ContainsField("Approved Application Lookup")) {
	        $field = $list.Fields.TryGetFieldByStaticName("ApprovedApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }
	 	
	    $list.Update($true)
    }

 }
 
  function DeleteSRSFieldsFromList($web) {      
    $calendarName="SRS Calendar"
    
	$list = $web.Lists[$calendarName];  
 	
 	if ($list -ne $null) 
    {
	    if ($list.Fields.ContainsField("ApplicationStudyLookup_x003A_Stu")) {
	        $field = $list.Fields.GetFieldByInternalName("ApplicationStudyLookup_x003A_Stu") 
	        $list.Fields.Delete($field)   
	    }
	
		if ($list.Fields.ContainsField("Application_x0020_Study_x0020_Lo")) {
	        $field = $list.Fields.GetFieldByInternalName("Application_x0020_Study_x0020_Lo") 
	        $list.Fields.Delete($field)   
	    }
	    
	    if ($list.Fields.ContainsField("RDCMinuteLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("RDCMinuteLookup")
	        $list.Fields.Delete($field)   
	    }
	    
	     if ($list.Fields.ContainsField("ApprovedRDCApplicationLookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedRDCApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }
	
	    if ($list.Fields.ContainsField("Approved Application Lookup")) {
	        $field = $list.Fields.GetFieldByInternalName("ApprovedApplicationLookup") 
	        $list.Fields.Delete($field)   
	    }
	
	    $list.Update($true)
    }

 }
 
#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)
