Add-PSSnapin Microsoft.SharePoint.Powershell

function GetAllWebs($url)
{
    try
    {
		foreach($web in $w.Webs)
	    {

			# Varibale to hold document count 
			$count = 0 
			
			###############################################################################  
			##  OPEN OBJECTS & RESTORE INHERITANCE ##  
			############################################################################### 
 
			try { 
			    # Open the web and list objects 
			    $web = Get-SPWeb $siteUrl 
			    $list = $web.Lists[$listName] 
			 
			    # If the list should inherit, reset the role inheritance 
			    if ($listInherits -eq $true) { 
			        $list.ResetRoleInheritance() 
			        Write-Host "Updated permissions on list." -foregroundcolor Green 
			    } 
			 
			    # Get all items with unique permissions 
			    $itemsWithUniquePermissions = $list.GetItemsWithUniquePermissions() 
			    Write-Host $itemsWithUniquePermissions.Count "number of items with unique permissions found." 
			 
			    # Only update items if some exist 
			    if ($itemsWithUniquePermissions.Count -gt 0) { 
			        foreach ($itemInfo in $itemsWithUniquePermissions) { 
			            $item = $list.GetItemById($itemInfo.Id) 
			            $filename = $item.Name.Trim();
			            if ($filename -eq "AgendaReport.aspx") {
			                $item.ResetRoleInheritance() 
			                $count++ 
			            }
			        } 
			 
			        # Display number of items updated 
			        Write-Host "Updated permissions on $count items." -foregroundcolor Green 
			    } 
			    else { 
			        Write-Host "No items with unique permissions exist, nothing to update." 
			    } 
			 
			    # Dispose of web object 
			    $web.Dispose() 
			} 
			catch [Exception] { 
			    Write-Host "Exception encountered.  Please ensure all arguments are valid." -foregroundcolor Red 
			    Write-Host $_.Exception.Message -foregroundcolor Red 
			}
		
	    }
	        
  
     		 	 
    }
    catch
    {
        Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    }   
 } 
    
###############################################################################  
##  SET VARIABLES FROM ARGUMENTS ##  
###############################################################################  
 #This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$listName = "Site Pages"
$listInherits = $false 
GetAllWebs($siteUrl)