﻿ <#
 2. In the SiteAssets library add the “<Facility> Users” security groups, e.g. Miami Users, Asheville Users, New Orleans Users, etc.  with read permission. 
PowerShell script [Chita]

Asheville Users
CIRB Users
Josh Template Testing Users
Miami Users
New Orleans Users
St Louis Users
Virtual Sites Users
 #>

 Add-PSSnapin Microsoft.SharePoint.Powershell

 function Add-SPPermissionToListGroup
{
    param ($Url, $ListName, $listUrl, $GroupName, $PermissionLevel)
    $web = Get-SPWeb -Identity $Url
    #$list = $web.Lists.TryGetList($ListName)
    $list = $web.GetListFromURL($listUrl)
    if ($list -ne $null)
    {
        # Ensure that the permissions are not being inherited.
        if ($list.HasUniqueRoleAssignments -eq $False)
        {
            $list.BreakRoleInheritance($True)
            Write-Host "Unique permission has been removed for  $ListName" -ForegroundColor Green
        }

        # Modify the permissions.
        if ($web.SiteGroups[$GroupName] -ne $null)
        {
            $group = $web.SiteGroups[$GroupName]
            $roleAssignment = new-object Microsoft.SharePoint.SPRoleAssignment($group)
            $roleDefinition = $web.RoleDefinitions[$PermissionLevel];
            $roleAssignment.RoleDefinitionBindings.Add($roleDefinition);
            $list.RoleAssignments.Add($roleAssignment)
            $list.Update();
            Write-Host "Successfully added $PermissionLevel permission to $GroupName group in $ListName list. " -foregroundcolor Green
        }
        else
        {
            Write-Host "Group $GroupName does not exist." -foregroundcolor Red
        }

    }
    $web.Dispose()
}
     #get site collection
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url

    #Set of all facility users
    $facilityUsers = @(
        "Asheville Users",
        "CIRB Users" ,
        "Josh Template Testing Users",
        "Miami Users" ,
        "New Orleans Users" ,
        "St Louis Users" ,
        "Virtual Sites Users" 
    );
    foreach ($facilityUser in $facilityUsers) {
        Add-SPPermissionToListGroup -Url $url -ListName SiteAssets -listUrl "SiteAssets/Forms/AllItems.aspx" -GroupName $facilityUser -PermissionLevel Read        
        Add-SPPermissionToListGroup -Url $url -ListName SiteAssets -listUrl "SitePages/Forms/AllPages.aspx" -GroupName $facilityUser -PermissionLevel Read        
     }
    