﻿Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue   

function getSiteURL {
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url
    return $url
}
   
 #Variables   
 $SiteURL = getSiteURL   
 
 $facilityList = @{
    "CIRB" = "Central IRB";
    "Virtual Sites" = "LocalSite2" 
 };
 

 #Get site and Group objects   
 $Site = Get-SPSite $SiteURL   

 #for each facility change the user groups to new names.
 foreach($key in $facilityList.Keys) {
    $Groups = $Site.RootWeb.SiteGroups
    foreach ($Group in $Groups) {
     if($Group.Name.Contains($key))   
         {   
            #get new group name
             $oldGroupName = $Group.ToString();
             $GroupNewName = $oldGroupName.Replace($key,$facilityList.Item($key))
             #sharepoint rename permission group             
             $Group.name = $GroupNewName   
             #Update the group   
             $Group.Update()   
             Write-host "Group Name has been updated! FROM: $oldGroupName TO: $GroupNewName" -ForegroundColor Cyan 
         }   
    }  
 }
 #for each facility change the ownership to local site administrator
     
 #dispose site object   
 $site.Dispose()  


