﻿Add-PSSnapin Microsoft.SharePoint.Powershell


$ArrayList = New-Object System.Collections.ArrayList


function formatOutput($listTable) {
  $listTable | Format-List
}

function getInternalName ($staticName, $list) {
    $list.Fields.TryGetFieldByStaticName($staticName).InternalName
    return;
}

function SyncFacilityList ($listUrl)
{

    #get a collection of ids
    $itemsToDelete = New-Object System.Collections.ArrayList
    
    #get site collection
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url

    $list = $w.GetListFromURL($listUrl)
    #get application list
    if($list -ne $null)
    {
        #Get all items in this list and save them to a variable
        $items = $list.items
        foreach($item in $items)
        {
            $correctFacilityName = $item["LocalSiteAdministrators"].Substring($item["LocalSiteAdministrators"].IndexOf("#")+1, $item["LocalSiteAdministrators"].IndexOf("Local Site Administrators")-6)
            Write-Host Facility name changed from $item["FacilityName"] to  $correctFacilityName  -ForegroundColor Cyan                                                                                                                             
            $item["FacilityName"] = $correctFacilityName;
            Write-Host Title name changed from $item["Title"] to  $correctFacilityName  -ForegroundColor Cyan                                                                                                                             
            $item["Title"] = $correctFacilityName;
            $item.Update();  
        }        
        $list.Update();
    }
}

#Delete Application list for older studies.
$listUrl = $url + "/Lists/Facility/AllItems.aspx"
SyncFacilityList -listUrl $listUrl




