﻿Add-PSSnapin Microsoft.SharePoint.Powershell


$CommitteeList = New-Object System.Collections.ArrayList


function formatOutput($listTable) {
  $listTable | Format-List
}

function getInternalName ($staticName, $list) {
    $list.Fields.TryGetFieldByStaticName($staticName).InternalName
    return;
}

$CommitteeList.Add("IRB")
$CommitteeList.Add("IACUC")
$CommitteeList.Add("RDC")
$CommitteeList.Add("SRS")

function SyncSiteConfigList 
{

    #get a collection of ids
    $itemsToDelete = New-Object System.Collections.ArrayList
    
    #get site collection
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url

    $srcList = $w.Lists.TryGetList("Committee List")
    $targetList = $w.Lists.TryGetList("Site Config")
    #delete all items from the site config list
    foreach($item in $targetList.Items) {
        $targetList.Items.GetItemById($item.ID).Delete();
    }
    $targetList.Update();
    #Populate the Site config list 
    if($srcList -ne $null)
    {
        #Get all items in this list and save them to a variable
        $items = $srcList.items
        foreach($item in $items)
        {
            $correctFacilityName = $item["LocalSiteAdministrators"].Substring($item["LocalSiteAdministrators"].IndexOf("#")+1, $item["LocalSiteAdministrators"].IndexOf("Local Site Administrators")-6)
            foreach($committee in $CommitteeList) {                
                $newItem = $targetList.AddItem();
                $newItem["Site"] = $correctFacilityName
                $newItem["Facility"] = $correctFacilityName
                $newItem["Committee"] = $committee
                $newItem.Update();
                Write-Host "Site: $correctFacilityName , Facility name: $correctFacilityName , Committee: $committee " -ForegroundColor Cyan 
            }           
            $item["Title"] = $correctFacilityName;
            $item.Update();  
        }        
        $targetList.Update();
    }
}

#Delete Application list for older studies.
SyncSiteConfigList




