﻿Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue   
   
 
function getSiteURL {
    $site = Get-SPSite -Limit All | Select-String IRBApplications
    $x = $site.ToString();
    $url = $x.Substring($x.IndexOf("=")+1)
    $w = Get-SPWeb $url
    return $url
}

#Variables   
 $SiteURL = getSiteURL   
 

 #Get site and Group objects   
 $Site = Get-SPSite $SiteURL   

 #for each facility change the ownership to local site administrator
 #for each facility change the user groups to new names.
 foreach($key in $groupList) {
    $Groups = $Site.RootWeb.SiteGroups
    foreach ($Group in $Groups) {
     if($Group.Name.Contains($key))   
         {   
            #get new group name   
            $newGroupOwnerName =  $key + " Local Site Administrators"                                             
            $newGroupOwner = $Site.RootWeb.SiteGroups[$newGroupOwnerName]
            if($key -ne "AO Group") {
                if($Group.Users.Count -ge 0) {
                    $Group.Owner = $newGroupOwner
                    $Group.OnlyAllowMembersViewMembership = $False
                    Write-host Added Group Owner: $newGroupOwnerName To=> $Group.Name  -ForegroundColor Cyan 
                    $Group.Update(); 
                 }
             }
         }   
    }  
 }

#Set the owner of the AO Group and RCO group to the Central IRB Local Site Administrator
$aOGroup = $Site.RootWeb.SiteGroups["AO Group"]
$rcoGroup = $Site.RootWeb.SiteGroups["RCO Group"]
$cirbGroup = $Site.RootWeb.SiteGroups["Central IRB Local Site Administrators"]
$aOGroup.Owner =  $cirbGroup
$rcoGroup.Owner =  $cirbGroup
$aOGroup.Update()
$rcoGroup.Update()

#Change AO group permission at site collection level to EDIT
$role = $Site.RootWeb.RoleDefinitions["Edit"]

$RoleAssignment = New-Object Microsoft.SharePoint.SPRoleAssignment($aOGroup)
$RoleAssignment.RoleDefinitionBindings.Add($role)

# the following could be for a web, list or item object
$Site.RootWeb.RoleAssignments.Add($RoleAssignment)
$Site.RootWeb.Update()
Write-Host "AO Group has been granted EDIT permission on $Site" -ForegroundColor Green
#dispose site object   
$site.Dispose();  
