Add-PSSnapin Microsoft.SharePoint.Powershell


function UpdateItem ($ParentWeb) {

    # GET THE LISTS

	#Where the Source List for Lookup Exists
	
	$ParentListName="Facility"
	$ParentLookupColumnName="Facility Name"
	
	#Where the Lookup Site column Going to get created
	$ChildLookupColumnName="DSFacilitySharedWith"
	
	#Get the Parent and Child Webs and List
	
	$ParentList = $ParentWeb.Lists[$ParentListName]
	$ChildWeb = $ParentWeb
	
	
	if($ChildWeb.Fields.ContainsField($ChildLookupColumnName))
	
	{
	
	    #Add Lookup Field
	
	    $ChildLookupColumn = $ParentWeb.Fields["Facility Shared With"]
	
	    #Setup lookup Field property
	
	    $ChildLookupColumn.LookupWebId = $ParentWeb.ID
	
	    $ChildLookupColumn.LookupField = $ParentList.Fields[$ParentLookupColumnName].InternalName
	
	    #$ChildLookupColumn.AllowMultipleValues=$true
	
	   	$ChildLookupColumn.Group="RAMS IRB" 
        $ChildLookupColumn.Title="Facility Shared With"

	    $ChildLookupColumn.update($true)
	
	    write-host "Lookup field added successfully!" -f green
	
	}
	
	else
	{
	
	    write-host "Field Exists already!" -f red
	
	} 

write-host "Lookup Field value has been updated!"
}

#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.itst.ram.msp.va.gov/sites/IRBApplications";
$w = Get-SPWeb $siteUrl;
UpdateItem($w)